// CookieHistoryDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "CookieHistoryDialog.h"
#include "commctrl.h"
#include "P3PPreferences.h"



/////////////////////////////////////////////////////////////////////////////
// CCookieHistoryDialog dialog


CCookieHistoryDialog::CCookieHistoryDialog() 
{
	// Store the pointer to the CP3PObject class
}


CCookieHistoryDialog::~CCookieHistoryDialog()
{
}


LRESULT CCookieHistoryDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{
	GMap<GString, GMap<GString, bool> > &cookie_history = P3PPreferences::cookie_history;
	

	HWND listhwnd = GetDlgItem(IDC_MAINSITE_LIST);
	if( listhwnd )
	{
		ListView_SetExtendedListViewStyleEx(listhwnd, LVS_SHOWSELALWAYS|LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP , LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP );
		LVCOLUMN lvc;
			    
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
		lvc.fmt = LVCFMT_LEFT; 
		
		char *headerlabels[] = {"Sitename"};
		int  column_sizes[] = {500};

		for(int i=0; i<(sizeof(headerlabels)/sizeof(void*)); i++)
		{
			lvc.pszText = headerlabels[i];
			lvc.iSubItem = i; 
			lvc.cx = column_sizes[i];
			ListView_InsertColumn(listhwnd, i, &lvc);
		}

		LVITEM lvi;
					
		lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
		lvi.state = 0;     lvi.stateMask = 0; 
		
		int index = 0;
		for( GPosition pos = cookie_history; pos; ++pos, index++ )
		{
			GString str = cookie_history.key(pos);
			lvi.iItem = index;
			lvi.iSubItem = 0; 
			lvi.pszText = (char*)(const char *)str;
			lvi.lParam = 0;
			int i = ListView_InsertItem(listhwnd, &lvi);
		}

		if( cookie_history.size() )
		{
			ListView_SetItemState(listhwnd, 0, LVIS_SELECTED, LVIS_SELECTED);
			GString str = GetSelectedItemText();
			if( str.length() && str != oldselstr )
			{
				oldselstr = str;
				PopulateOtherSites(str);
			}
		}

	}

	HWND listotherhwnd = GetDlgItem(IDC_OTHERSITE_LIST);
	if( listotherhwnd )
	{
		ListView_SetExtendedListViewStyleEx(listotherhwnd, LVS_SHOWSELALWAYS|LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP , LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP );
		LVCOLUMN lvc;
			    
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
		lvc.fmt = LVCFMT_LEFT; 
		
		char *headerlabels[] = {"Sitename"};
		int  column_sizes[] = {500};

		for(int i=0; i<(sizeof(headerlabels)/sizeof(void*)); i++)
		{
			lvc.pszText = headerlabels[i];
			lvc.iSubItem = i; 
			lvc.cx = column_sizes[i];
			ListView_InsertColumn(listotherhwnd, i, &lvc);
		}
	}


	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT CCookieHistoryDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT CCookieHistoryDialog::OnOK(WORD, WORD, HWND, BOOL&)
{

	EndDialog(IDOK);
	return 1;

}

LRESULT CCookieHistoryDialog::OnNotify(UINT code, WPARAM wParam, LPARAM lParam, BOOL& result)
{

	LPNMHDR pmhdr = (LPNMHDR) lParam;
	if( pmhdr->idFrom == IDC_MAINSITE_LIST )
	{
		GString str = GetSelectedItemText();
		if( str.length() && str != oldselstr )
		{
			oldselstr = str;
			PopulateOtherSites(str);
		}
	}

	return FALSE;
}


GString CCookieHistoryDialog::GetSelectedItemText()
{
	HWND ListWnd=GetDlgItem(IDC_MAINSITE_LIST);
	int i=ListView_GetNextItem(ListWnd, -1, LVNI_SELECTED);
	if( i >= 0 )
	{
		char buffer[1024];
		buffer[0] = 0;
		LVITEM lvi;
				
		lvi.mask = LVIF_TEXT ;
		lvi.state = 0;     
		lvi.stateMask = 0; 
		lvi.lParam=0;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = buffer;
		lvi.cchTextMax = sizeof(buffer);
		if( ListView_GetItem(ListWnd, &lvi) )
		{
			return buffer;
		}
	}
	return "";
}

void CCookieHistoryDialog::PopulateOtherSites(GString &site)
{
	GMap<GString, GMap<GString, bool> > &cookie_history = P3PPreferences::cookie_history;
	
	if( GPosition pos = cookie_history.contains(site) )
	{
		GMap<GString, bool> othersites = cookie_history[pos];

		HWND othersitelisthwnd = GetDlgItem(IDC_OTHERSITE_LIST);
		if( othersitelisthwnd )
		{
			ListView_DeleteAllItems( othersitelisthwnd);		
			LVITEM lvi;
						
			lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
			lvi.state = 0;     
			lvi.stateMask = 0; 
			
			int index = 0;
			for( GPosition pos = othersites; pos; ++pos, index++ )
			{
				GString str = othersites.key(pos);
				lvi.iItem = index;
				lvi.iSubItem = 0; 
				lvi.pszText = (char*)(const char *)str;
				lvi.lParam = 0;
				int i = ListView_InsertItem(othersitelisthwnd, &lvi);
			}
		}

/*		HWND statichwnd = GetDlgItem(IDC_SITE_STATIC);
		if( statichwnd )
		{
			GString str = "Cookies were identified at the following third party sites at "+site;
			::SetWindowText(statichwnd, (const char*)str);
		}
*/
	}
}


LRESULT CCookieHistoryDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDCANCEL);
	return 1;

}