// CookieSettingsDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "CookieSettingsDialog.h"
#include "P3PPreferences.h"
#include "commctrl.h"
#include "CustomCookieSettingsDialog.h"
#include "Globals.h"



/////////////////////////////////////////////////////////////////////////////
// CCookieSettingsDialog dialog

static DWORD help_array[] = {
							IDC_GROUP_COOKIESETTINGS, IDH_GROUP_COOKIESETTINGS,
							IDC_COOKIE_MATCHING, IDH_COOKIE_MATCHING,
							IDC_COOKIE_ALL, IDH_COOKIE_ALL,
							IDC_COOKIE_NONE, IDH_COOKIE_NONE,
							IDC_COOKIE_CUSTOM, IDH_COOKIE_CUSTOM,
							IDC_CUSTOMCOOKIESETTINGS, IDH_COOKIE_CUSTOM,
							0,0
						};



CCookieSettingsDialog::CCookieSettingsDialog() 
{
	// Store the pointer to the CP3PObject class
}


CCookieSettingsDialog::~CCookieSettingsDialog()
{
}


LRESULT CCookieSettingsDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{

	switch (g_p3p_preferences.allow_cookies)
	{
	case P3PPreferences::MATCHING_PREFERENCES :
		CheckDlgButton(IDC_COOKIE_MATCHING, BST_CHECKED); break;

	case P3PPreferences::ALL :
		CheckDlgButton(IDC_COOKIE_ALL, BST_CHECKED); break;

	case P3PPreferences::NONE :
		CheckDlgButton(IDC_COOKIE_NONE, BST_CHECKED); break;

	case P3PPreferences::CUSTOM_COOKIE :
		{
			CheckDlgButton(IDC_COOKIE_CUSTOM, BST_CHECKED); 
			::EnableWindow(GetDlgItem(IDC_CUSTOMCOOKIESETTINGS), TRUE);
		}
		break;



	}

	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT CCookieSettingsDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT CCookieSettingsDialog::OnOK(WORD, WORD, HWND, BOOL&)
{

	int save_allow_cookies = g_p3p_preferences.allow_cookies;
	
	if (IsDlgButtonChecked(IDC_COOKIE_MATCHING) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies = P3PPreferences::MATCHING_PREFERENCES;
	}
	else if (IsDlgButtonChecked(IDC_COOKIE_ALL) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies = P3PPreferences::ALL;
	} 
	else if (IsDlgButtonChecked(IDC_COOKIE_NONE) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies = P3PPreferences::NONE;
	} 
	else if (IsDlgButtonChecked(IDC_COOKIE_CUSTOM) == BST_CHECKED)
	{
		g_p3p_preferences.allow_cookies = P3PPreferences::CUSTOM_COOKIE;
	} 

	if ( g_p3p_preferences.allow_cookies != save_allow_cookies )
	{
		g_p3p_preferences.CookieSave(g_dllpath+COOKIE_FILE);
		SendCommandToAllP3Ps(ID_CHANGED_COOKIE_SETTINGS);
	}

	EndDialog(IDOK);
	return 1;

}

LRESULT CCookieSettingsDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDCANCEL);
	return 1;

}

LRESULT CCookieSettingsDialog::OnContextHelp(UINT id, WPARAM wParam, LPARAM lParam, BOOL& bFlag)
{
	HELPINFO* pHelpInfo = (LPHELPINFO) lParam;
	
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp( (HWND)pHelpInfo->hItemHandle, g_dllpath+"\\p3pclient.chm::/ContextSensitiveHelp.txt",
				HH_TP_HELP_WM_HELP, (DWORD)(LPVOID)help_array)  != NULL;
	}
	return 1;

}

LRESULT CCookieSettingsDialog::OnCustomCookieSettings(WORD, WORD, HWND, BOOL&)
{
	CCustomCookieSettingsDialog sd;
	//if (sd.DoModal() == IDOK)
	//	EndDialog(IDOK);
	sd.DoModal();
	return 1;
}

LRESULT CCookieSettingsDialog::OnClickedAllowcookies(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// TODO : Add Code for control notification handler.
	::EnableWindow(GetDlgItem(IDC_CUSTOMCOOKIESETTINGS), FALSE);
	return 0;
}
LRESULT CCookieSettingsDialog::OnClickedAllowcookies_formatchedsites(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// TODO : Add Code for control notification handler.
	::EnableWindow(GetDlgItem(IDC_CUSTOMCOOKIESETTINGS), FALSE);
	return 0;
}
LRESULT CCookieSettingsDialog::OnClickedCustomsettings(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// TODO : Add Code for control notification handler.
	::EnableWindow(GetDlgItem(IDC_CUSTOMCOOKIESETTINGS), TRUE);
	return 0;
}
LRESULT CCookieSettingsDialog::OnClickedNeverallowcookies(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// TODO : Add Code for control notification handler.
	::EnableWindow(GetDlgItem(IDC_CUSTOMCOOKIESETTINGS), FALSE);
	return 0;
}


LRESULT CCookieSettingsDialog::OnHelp(WORD, WORD, HWND, BOOL&)
{
	return HtmlHelp( NULL, g_dllpath+"\\p3pclient.chm::/help-cookiepreferences.html",
				HH_DISPLAY_TOPIC, 0)  != NULL;

}


