#ifndef __COOKIEMAN_CALLS_H__
#define __COOKIEMAN_CALLS_H__


typedef int _stdcall  CM_t_CbThreadDataFromBho(DWORD threadID, char *jar, char *url);

// new interface for the AT&T Companion
// first parameter: threadId (top-level).
// bCookieRecieved: cookie received or sent (SET or GET)
// should_jam: BHO returns wether the cookie should be jammed.
// bIsTracker: ThirdParty of First Party cookie.
//in the GET events, the callback will be fired twice: 
//ONCE WITH NULL:	shuold say if return all or just session cookies. 
//SECOND: with the cookie list to be edited. (the editing can only substract, not add -> the buffer is pre-allocated).
//in the GET event, multiple cookies per call. 
//in the SET event, the callback will be fired once: 
//with the values of the cookie, and the result should be: block or not block. 
//in the SET event, only one cookie per call. 

typedef int _stdcall  CM_t_CbInformCookieEventToBHO(DWORD threadID, BOOL
							bCookieRecieved, char* cookies_data, BOOL* should_jam, BOOL bIsTracker, char *TrackerDomain, char* SiteDomain);

// this is the callback function prototype of the BHO.
// CookieMan calls it with whenever a redirection is detected
// with the thread id and the new redirected URL
// If the redirection needs a change of hat, the BHO returns CM_S_OK
// and fills the Jar parameter with the new Jar Name.
// if the BHO doesn't need to change hat, it returns CM_S_FAIL
typedef int _stdcall  CM_t_CbInformRedirectionToBHO(DWORD threadID, char *OriginURL, char *RedirectedURL, char* NewJarName);


// This function call gets the sensitivity for a threadId from the BHO: threadId corresponds to threadId 
// of WebBrowser instance, and the sensitivity is the bitmask. 
// currently, only fourth and third bit are sufficient to control referer transmission in third, first party context respectively

typedef int _stdcall  CM_t_CbGetURLSensitivityFromBHO(DWORD threadID, int *Sensitivity);



typedef  int TCM_RegisterBho( CM_t_CbThreadDataFromBho*,
                                 CM_t_CbInformCookieEventToBHO*,
                                 CM_t_CbInformRedirectionToBHO*,
                                 CM_t_CbGetURLSensitivityFromBHO*);

typedef int TCM_UnregisterBho();

typedef void TCM_UpdateTrackersBlackList( char *NewTrackersBlackList);
                              
typedef void TCM_EnableIDcide( int bEnable);
                      
typedef void TCM_CleanRequests( long TopLevelThreadID);

typedef HRESULT TCM_GetProxySettings( char *Server, DWORD* Size, DWORD* Port);

#endif