// EmbeddedContentDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "IconDialog.h"
#include "commctrl.h"
#include "PrivacySettingsDialog.h"
#include "CookieSettingsDialog.h"
#include "OtherSettingsDialog.h"
#include "OverrideSettingsDialog.h"
#include "FullPolicyDialog.h"
#include "PolicySummaryDialog.h"
#include "Globals.h"
#include "PolicyHandler.h"
#include "ViewPolicyDialog.h"
#include "EmbeddedContentDialog.h"


HANDLE CEmbeddedContentDialog::ascbmp=0, CEmbeddedContentDialog::descbmp=0;


int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)  
{
	if( lParam1 > lParam1 )
	{
		return 1;
	}
	else if( lParam1 < lParam1 )
	{
		return -1;
	}
	else
		return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CEmbeddedContentDialog dialog


CEmbeddedContentDialog::CEmbeddedContentDialog(P3PMatchInfo &minfo): matchinfo(minfo)
{
	// Store the pointer to the CP3PObject class
}


CEmbeddedContentDialog::~CEmbeddedContentDialog()
{
}


LRESULT CEmbeddedContentDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{
	EnableButtons(false);

	HWND listhwnd=GetDlgItem(IDC_CONTENT_LIST);
	if( listhwnd )
	{
		ListView_SetExtendedListViewStyleEx(listhwnd, LVS_SHOWSELALWAYS|LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP , LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP );
		LVCOLUMN lvc;
			    
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
		lvc.fmt = LVCFMT_LEFT; 
		
		char *headerlabels[] = {"URL", "Privacy Check", "Type", "Applicable Policy"};
		int  column_sizes[] = {350, 100, 100, 200};

		for(int i=0; i<(sizeof(headerlabels)/sizeof(void*)); i++)
		{
			lvc.pszText = headerlabels[i];
			lvc.iSubItem = i; 
			lvc.cx = column_sizes[i];
			ListView_InsertColumn(listhwnd, i, &lvc);
		}

		LVITEM lvi;
				
		lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
		lvi.state = 0;     lvi.stateMask = 0; 
		

		GList<GURL> urllist;
		matchinfo.GetEmbeddedURLList(urllist);

		int index = 0;
		for( GPosition pos = urllist; pos; ++pos, index++ )
		{
			GURL url = urllist[pos];
			lvi.iItem = index;
			lvi.iSubItem = 0; 
			lvi.pszText = (char*)(const char *)url;
			lvi.lParam = matchinfo.GetEmbeddedResult(url);
			int i = ListView_InsertItem(listhwnd, &lvi);

			GString resultstr;	

			switch( lvi.lParam )
			{
				case Result::MATCH: resultstr = "Matched";
				break;
				case Result::UNMATCH: resultstr = "UnMatched";
				break;
				case Result::UNKNOWN: resultstr = "Unknown";
				break;
				default : resultstr = "Unknown match type, Bug some where";
				break;
			}

			ListView_SetItemText(listhwnd, i, 1, (char*)(const char *)resultstr);

			///set type here
			ListView_SetItemText(listhwnd, i, 2, (char*)(const char *)matchinfo.GetEmbeddedURLType(url));

			///Set Policy URL here
			GURL purl = matchinfo.GetPolicyURL(url);
			ListView_SetItemText(listhwnd, i, 3, (char*)(const char *)purl);
		}

		//prepare header image list

	/*	HIMAGELIST imglist = ImageList_Create(16, 16, TRUE, 2, 0);
		if( imglist )
		{
			HICON hicon = LoadIcon(hinst, MAKEINTRESOURCE(IDI_ASCENDING)); 
			ImageList_AddIcon(imglist, hicon); 
 
			LoadIcon(hinst, MAKEINTRESOURCE(IDI_DESCENDING)); 
			ImageList_AddIcon(imglist, hicon);

			HWND header = ListView_GetHeader(listhwnd);
			Header_SetImageList(header, imglist);
		}
		*/
		if( !ascbmp )
			ascbmp = LoadImage(hinst, MAKEINTRESOURCE(IDB_ASCENDING), IMAGE_BITMAP, 0, 0, LR_LOADTRANSPARENT);
		if( !descbmp )
			descbmp = LoadImage(hinst, MAKEINTRESOURCE(IDB_DESCENDING), IMAGE_BITMAP, 0, 0, LR_LOADTRANSPARENT);
	}

	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT CEmbeddedContentDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT CEmbeddedContentDialog::OnOK(WORD, WORD, HWND, BOOL&)
{

	EndDialog(IDOK);
	return 1;

}
LRESULT CEmbeddedContentDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDCANCEL);
	return 1;

}

LRESULT CEmbeddedContentDialog::OnContextHelp(UINT id, WPARAM wParam, LPARAM lParam, BOOL& bFlag)
{
	::MessageBeep(MB_OK);
	return 1;
}

LRESULT CEmbeddedContentDialog::OnNotify(UINT code, WPARAM wParam, LPARAM lParam, BOOL& result)
{
	LPNMHDR pmhdr = (LPNMHDR) lParam;
	if( pmhdr->idFrom == IDC_CONTENT_LIST )
	{
		unsigned int i = ListView_GetSelectedCount(GetDlgItem(IDC_CONTENT_LIST));
		if( GetSelectedItemLParam() > Result::UNKNOWN )
		{
			EnableButtons(i);
		}
		else
			EnableButtons(0);


		switch( pmhdr->code )
		{
		case NM_DBLCLK:
			{
				if( GetSelectedItemLParam() > Result::UNKNOWN )
				{
//					EnableButtons(i);

					BOOL result;
					OnPolicySummary(0,0,m_hWnd,result);
				}
//				else
//					EnableButtons(FALSE);

				
			} break;
		case NM_RCLICK:
			{
				if( GetSelectedItemLParam() > Result::UNKNOWN )
				{
//					EnableButtons(i);
					
					LPNMLISTVIEW pnm=(LPNMLISTVIEW) lParam;
					HMENU menu = LoadMenu(hinst, MAKEINTRESOURCE(IDR_EMBEDDED_POPUP));
					HMENU popup = GetSubMenu(menu,0);
					POINT p=pnm->ptAction;
					
					::ClientToScreen(pnm->hdr.hwndFrom,&p);
					TrackPopupMenuEx(popup,TPM_RIGHTBUTTON,p.x,p.y,this->m_hWnd,NULL);
				}

			} break;

		case NM_CLICK:
			{
//				if( GetSelectedItemLParam() > Result::UNKNOWN )
//					EnableButtons(i);
//				else
//					EnableButtons(FALSE);
//
			} break;
		case LVN_COLUMNCLICK:
			{
				OnColumnClickContentList(pmhdr->idFrom, (LPNMLISTVIEW)pmhdr, result);
			} break;
		}
	}
	return FALSE;
}


LRESULT CEmbeddedContentDialog::OnPolicySummary(WORD, WORD, HWND, BOOL&)
{
	HWND ListWnd=GetDlgItem(IDC_CONTENT_LIST);
	int i=ListView_GetNextItem(ListWnd, -1, LVNI_SELECTED);
	if( i >= 0 )
	{
		char buffer[2048];
		LVITEM lvi;
				
		lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
		lvi.state = 0;     lvi.stateMask = 0; 
		lvi.lParam=0;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = buffer;
		lvi.cchTextMax = sizeof(buffer);

		if( ListView_GetItem(ListWnd, &lvi) )
		{
			GURL url = buffer;
			Result result(url);
			if( matchinfo.GetEmbeddedResult(url, result) )
			{
				if( result.Match != Result::UNKNOWN )
				{
					CPolicySummaryDialog psdlg(result);
					psdlg.DoModal();
				}
			}
		}
	}

return TRUE;
}

LRESULT CEmbeddedContentDialog::OnViewPolicy(WORD, WORD, HWND, BOOL&)
{
	HWND ListWnd=GetDlgItem(IDC_CONTENT_LIST);
	int i=ListView_GetNextItem(ListWnd, -1, LVNI_SELECTED);
	if( i >= 0 )
	{
		char buffer[2048];
		LVITEM lvi;
				
		lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE;
		lvi.state = 0;     lvi.stateMask = 0; 
		lvi.lParam=0;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = buffer;
		lvi.cchTextMax = sizeof(buffer);

		if( ListView_GetItem(ListWnd, &lvi) )
		{
			GURL url = buffer; 
			
			GURL purl = matchinfo.GetPolicyURL(url);
			if( !purl.is_empty() )
			{
				GString localpath = g_policy_handler.GetLocalPathFromCache(purl);
				if( localpath.length() > 0 )
				{
					CViewPolicyDialog sd(purl, localpath);
					sd.DoModal();
				}
				/*char *data = g_policy_handler.GetURL(purl, false, false);
				//CViewPolicyDialog vpd(purl, data);
				//vpd.DoModal();
				if( data )
					delete data;*/
			}
		}
	}

return TRUE;
}

void CEmbeddedContentDialog::EnableButtons(int enable)
{
	if( enable )
	{
		::EnableWindow(GetDlgItem(ID_POLICY_SUMMARY), TRUE);
		::EnableWindow(GetDlgItem(ID_VIEW_SOURCE), TRUE);
	}
	else
	{
		::EnableWindow(GetDlgItem(ID_POLICY_SUMMARY), FALSE);
		::EnableWindow(GetDlgItem(ID_VIEW_SOURCE), FALSE);
	}
}

int CEmbeddedContentDialog::GetSelectedItemLParam()
{
	HWND ListWnd=GetDlgItem(IDC_CONTENT_LIST);
	int i=ListView_GetNextItem(ListWnd, -1, LVNI_SELECTED);
	if( i >= 0 )
	{
		LVITEM lvi;
				
		lvi.mask = LVIF_PARAM;
		lvi.state = 0;     
		lvi.stateMask = 0; 
		lvi.lParam=0;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		if( ListView_GetItem(ListWnd, &lvi) )
		{
			return lvi.lParam;
		}
	}
	return -1;
}


LRESULT CEmbeddedContentDialog::OnColumnClickContentList(int idCtrl, LPNMLISTVIEW pnmh, BOOL& bHandled)
{
	HWND listhwnd=GetDlgItem(IDC_CONTENT_LIST);

	HDITEM item;
	item.mask = HDI_LPARAM;
	Header_GetItem(ListView_GetHeader(listhwnd), pnmh->iSubItem, &item);
	if( item.lParam )
		SetHeaderImage(ListView_GetHeader(listhwnd), pnmh->iSubItem, 0);
	else
		SetHeaderImage(ListView_GetHeader(listhwnd), pnmh->iSubItem, 1);

	int count = ListView_GetItemCount(listhwnd);
	for( int i=0; i<count; i++)
	{
		for (int j=i+1; j<count; j++)
		{
			SwitchItems(i, j, pnmh->iSubItem, item.lParam);
		}
	}


/*
	PFNLVCOMPARE pfnCompare = (PFNLVCOMPARE) *CompareFunc;
	LPARAM lParamSort = (LPARAM)"Result" ;
	ListView_SortItems(listhwnd, pfnCompare, lParamSort);
	*/

	return 0;
}



LRESULT CEmbeddedContentDialog::OnHelp(WORD, WORD, HWND, BOOL&)
{
	return HtmlHelp( NULL, g_dllpath+"\\p3pclient.chm::/help-embeddedcontent.html",
				HH_DISPLAY_TOPIC, 0)  != NULL;

}

void CEmbeddedContentDialog::SwitchItems(int i, int j, int compareColumn, int ascdesc)
{
	HWND ListWnd=GetDlgItem(IDC_CONTENT_LIST);
	if( i >= 0 && j >= 0 && i != j && ListWnd)
	{
		char iurl[1024], icheck[50], itype[50], ipolicy[1024];
		char jurl[1024], jcheck[50], jtype[50], jpolicy[1024];
		int ilparam, jlparam;

		LVITEM lvi;

		//for i item
				
		lvi.mask = LVIF_PARAM;
		lvi.state = 0;     
		lvi.stateMask = 0; 
		lvi.lParam=0;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		ListView_GetItem(ListWnd, &lvi);
		ilparam = lvi.lParam;

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 0;
		lvi.pszText = iurl;
		lvi.cchTextMax = sizeof(iurl);
		ListView_GetItem(ListWnd, &lvi);

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 1;
		lvi.pszText = icheck;
		lvi.cchTextMax = sizeof(icheck);
		ListView_GetItem(ListWnd, &lvi);

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 2;
		lvi.pszText = itype;
		lvi.cchTextMax = sizeof(itype);
		ListView_GetItem(ListWnd, &lvi);

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 3;
		lvi.pszText = ipolicy;
		lvi.cchTextMax = sizeof(ipolicy);
		ListView_GetItem(ListWnd, &lvi);

		lvi.mask = LVIF_PARAM;
		lvi.state = 0;     
		lvi.stateMask = 0; 
		lvi.lParam=0;
		lvi.iItem = j;
		lvi.iSubItem = 0;
		ListView_GetItem(ListWnd, &lvi);
		jlparam = lvi.lParam;

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 0;
		lvi.pszText = jurl;
		lvi.cchTextMax = sizeof(jurl);
		ListView_GetItem(ListWnd, &lvi);

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 1;
		lvi.pszText = jcheck;
		lvi.cchTextMax = sizeof(jcheck);
		ListView_GetItem(ListWnd, &lvi);

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 2;
		lvi.pszText = jtype;
		lvi.cchTextMax = sizeof(jtype);
		ListView_GetItem(ListWnd, &lvi);

		lvi.mask = LVIF_TEXT;
		lvi.iSubItem = 3;
		lvi.pszText = jpolicy;
		lvi.cchTextMax = sizeof(jpolicy);
		ListView_GetItem(ListWnd, &lvi);

		int switems=false;
		switch(compareColumn)
		{
			case 0: switems = ascdesc?GString(iurl) < GString(jurl):GString(iurl) > GString(jurl); break;
			case 1: switems = ascdesc?GString(icheck) < GString(jcheck):GString(icheck) > GString(jcheck); break;
			case 2: switems = ascdesc?GString(itype) < GString(jtype):GString(itype) > GString(jtype); break;
			case 3: switems = ascdesc?GString(ipolicy) < GString(jpolicy):GString(ipolicy) > GString(jpolicy); break;
		}

		if( switems )
		{
			lvi.mask = LVIF_PARAM|LVIF_TEXT;
			lvi.state = 0;     
			lvi.stateMask = 0; 
			lvi.lParam=jlparam;
			lvi.iItem = i;
			lvi.iSubItem = 0;
			lvi.pszText = jurl;
			ListView_SetItem(ListWnd, &lvi);
			ListView_SetItemText(ListWnd, i, 1, jcheck);
			ListView_SetItemText(ListWnd, i, 2, jtype);
			ListView_SetItemText(ListWnd, i, 3, jpolicy);

			lvi.mask = LVIF_PARAM|LVIF_TEXT;
			lvi.state = 0;     
			lvi.stateMask = 0; 
			lvi.lParam=jlparam;
			lvi.iItem = j;
			lvi.iSubItem = 0;
			lvi.pszText = iurl;
			ListView_SetItem(ListWnd, &lvi);
			ListView_SetItemText(ListWnd, j, 1, icheck);
			ListView_SetItemText(ListWnd, j, 2, itype);
			ListView_SetItemText(ListWnd, j, 3, ipolicy);
			
		}
	}
}

void CEmbeddedContentDialog::SetHeaderImage(HWND header, int colIndex, int ascdescimg)
{
	HDITEM item;
	item.mask = HDI_BITMAP|HDI_LPARAM;
	item.fmt = HDF_BITMAP_ON_RIGHT|HDF_LEFT;
	item.lParam = ascdescimg;

	if( ascdescimg )
		item.hbm  = (HBITMAP)descbmp;
	else
		item.hbm  = (HBITMAP)ascbmp;

	int i = Header_SetItem(header, colIndex, &item);	
}

