#ifndef __EmbeddedContentDLG_H_
#define __EmbeddedContentDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "P3PMatchInfo.h"


/////////////////////////////////////////////////////////////////////////////
// CEmbeddedContentDialog dialog

class CEmbeddedContentDialog : public CAxDialogImpl<CEmbeddedContentDialog>
{
	P3PMatchInfo &matchinfo;
// Construction
public:
	CEmbeddedContentDialog(P3PMatchInfo &matchinfo);   // constructor

	~CEmbeddedContentDialog();
	
	enum { IDD = IDD_EMBEDDED_CONTENT };

BEGIN_MSG_MAP(CEmbeddedContentDialog)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_HELP, OnContextHelp)
	MESSAGE_HANDLER(WM_NOTIFY, OnNotify )
	COMMAND_ID_HANDLER(IDOK, OnOK)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	COMMAND_ID_HANDLER(ID_POLICY_SUMMARY, OnPolicySummary)
	COMMAND_ID_HANDLER(ID_VIEW_SOURCE, OnViewPolicy)
	COMMAND_ID_HANDLER(IDC_MYHELP, OnHelp)
//	NOTIFY_HANDLER(IDC_CONTENT_LIST, LVN_COLUMNCLICK, OnColumnClickContentList)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnOK(WORD, WORD, HWND, BOOL&);
	LRESULT OnCancel(WORD, WORD, HWND, BOOL&);
	LRESULT OnContextHelp(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnNotify(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnPolicySummary(WORD, WORD, HWND, BOOL&);
	LRESULT OnViewPolicy(WORD, WORD, HWND, BOOL&);
	LRESULT OnHelp(WORD, WORD, HWND, BOOL&);
	LRESULT OnColumnClickContentList(int idCtrl, LPNMLISTVIEW pnmh, BOOL& bHandled);
private:
	void EnableButtons(int enable);
	int GetSelectedItemLParam();
	void SwitchItems(int i, int j, int compareColumn, int ascdesc);
	void SetHeaderImage(HWND header, int colIndex, int ascdescimg);

	static HANDLE ascbmp, descbmp;


};


#endif 