#include "stdafx.h"
#include "Globals.h"
#include <commctrl.h>
#include <time.h>
#include <wininet.h>
#include "GContainer.h"
#include "GString.h"
#include "GOS.h"
#include "P3PPreferences.h"

bool g_enabled = true;
bool g_onTitleBar = true;
POINT g_Position={50, 50};
HINSTANCE hinst=NULL;
GString g_dllpath;
HBITMAP h_unknown = 0;
HBITMAP h_match = 0;
HBITMAP h_nomatch = 0;
HBITMAP h_disable = 0;

//GMap<GURL, bool> g_dontwarnsitelist;


/////////////////////////////////////////////////////////////////////

struct callbackstruct
{
	int command;
	DWORD processId;
	GMap<DWORD, bool> processedIds;
};

BOOL CALLBACK SendCommandEnumWindowsProc(
  HWND hwnd,      // handle to parent window
  LPARAM lParam   // application-defined value
)
{
	callbackstruct *cbs = (callbackstruct*) lParam;
	if( hwnd && GetProp(hwnd, "P3PMainWindow")==(HANDLE)0xFACEFACE )
	{
		if( cbs->processId == 0 )
		{
			::PostMessage(hwnd, WM_COMMAND,  cbs->command, 0);
		}
		else 
		{
			DWORD processId;
			GetWindowThreadProcessId(hwnd, &processId );
			if( processId != cbs->processId && !cbs->processedIds.contains(processId) )
			{
				cbs->processedIds[processId] = true;
				::PostMessage(hwnd, WM_COMMAND,  cbs->command, 0);
			}
		}
	}
	return TRUE;
}

void SendCommandToAllP3Ps(int command, bool all_windows)
{
	callbackstruct cbs;
	cbs.command = command;
	if( all_windows )
		cbs.processId = 0;
	else
		cbs.processId = GetCurrentProcessId();
	EnumWindows(SendCommandEnumWindowsProc, (LPARAM)&cbs);
}

/////////////////////////////////////////////////////////////////////

GString tempfilename( GString &directory )
{
	static unsigned short suffix = 0;
	static GCriticalSection name_lock;

	GCriticalSectionLock lock(&name_lock);
	GString name;
	GString gname;
	do
	{
		suffix++;
		name = GString("temp")+GString((int)suffix);
		gname = directory + "\\"+name;
	}
	while( GOS::is_file(gname) || GOS::is_dir(gname));

	return name;
}


static void UnixTimeToFileTime(time_t t, LPFILETIME pft)
{
	// Note that LONGLONG is a 64-bit value
	LONGLONG ll;

	ll = Int32x32To64(t, 10000000) + 116444736000000000;
	pft->dwLowDateTime = (DWORD)ll;
	pft->dwHighDateTime = (DWORD)(ll >> 32);
}


void UnixTimeToSystemTime(time_t t, LPSYSTEMTIME pst)
{
	FILETIME ft;

	UnixTimeToFileTime(t, &ft);
	FileTimeToSystemTime(&ft, pst);
}

static void FileTimeToUnixTime(LPFILETIME pft, time_t &t)
{
	// Note that LONGLONG is a 64-bit value
	LONGLONG ll;

	ll = pft->dwHighDateTime;
	ll <<= 32;
	ll += pft->dwLowDateTime;

	t = (long)((ll - 116444736000000000) / 10000000);
}

time_t SystemTimeToUnixTime( LPSYSTEMTIME pst)
{
	FILETIME ft;
	SystemTimeToFileTime(pst, &ft);
	time_t t;
	FileTimeToUnixTime(&ft, t);
	return t;
}

time_t InternetTimeToUnixTime(const char *it)
{
	if(it)
	{
		SYSTEMTIME st;
		if( InternetTimeToSystemTime(it, &st, 0) )
		{
			time_t tt = SystemTimeToUnixTime(&st);
			if( tt == 0 )
				THROW("Invalid TIME string");
			return tt;
		}
		else
			THROW("Invalid TIME string");
	}
	return 0;
}

GString AddReturns(const char*str)
{

	GString result;
	int len = strlen(str);
	for( int i=0; i<len; i++)
	{
		if( i>0 && str[i-1] != '\r' && str[i] == '\n' )
		{
			result += '\r';
		}
		result += str[i];
	}
	return result;
}


void SetToolTipText(HWND tooltip, TCHAR *text)
{
	if( tooltip )
    {
		HWND parent = GetParent(tooltip);
        TOOLINFO toolinfo;
        memset(&toolinfo, 0, sizeof(toolinfo));

	    toolinfo.cbSize = sizeof(TOOLINFO);
        toolinfo.hwnd   = parent;   
	    toolinfo.uId    = (UINT)parent;
        toolinfo.hinst  = hinst;
		toolinfo.lpszText  = text;

	    SendMessage(tooltip, TTM_UPDATETIPTEXT, 0, (LPARAM)&toolinfo);
    }
}


HWND AddToolTipToControl(HWND cntwnd, TCHAR *text)
{

    HWND tooltip = CreateWindow(TOOLTIPS_CLASS, NULL, TTS_ALWAYSTIP,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
        cntwnd, (HMENU) NULL, hinst, NULL); 

    if( tooltip )
    {
        TOOLINFO toolinfo;
        memset(&toolinfo, 0, sizeof(toolinfo));

	    toolinfo.cbSize = sizeof(TOOLINFO);
        toolinfo.uFlags =  TTF_SUBCLASS|TTF_IDISHWND ;
        toolinfo.hwnd   = cntwnd;   
	    toolinfo.uId    = (UINT)cntwnd;
        toolinfo.hinst  = hinst;    
	    toolinfo.lpszText  = text;

        RECT r;
        GetWindowRect(cntwnd, &r);
        toolinfo.rect = r;
        

	    SendMessage(tooltip, TTM_ADDTOOL, 0, (LPARAM)&toolinfo);
		SendMessage(tooltip, TTM_SETMAXTIPWIDTH, 0, 500);
    }

return tooltip;
}



//////////////////////////////////////////////////////////////////////////////////////
/************************************************************************************/
//////////////////////////////////////////////////////////////////////////////////////

/* external variables */
WIDE_CHAR_STANDARD_T widechar = NO_WC_STANDARD;	

void *xrealloc(void *s, size_t n)
{
    void *p;

    if (s == NULL)
        return n ? new char[n+1] : NULL;
    if (n == 0) {
        delete s;
        return NULL;
    }
    p = new char[n+1];
	memcpy(p, s, n);
	delete s;
   
    return p;
}

/* return a copy of a string */
char *xstrdup(char *s)
{
	char *p = new char[strlen(s)+1];
	strcpy(p,s);
    return p;
}

	

/* convert a WideChar to a string of UTF-8 chars */
GString cvt_wc_to_utf8(unsigned long c)
{
#define CS 5
    static const unsigned long conversion[] = {
        0, 0x7F, 1, 7, 0,
        0x80, 0x7FF, 2, 11, 0xC0,
        0x800, 0xFFFF, 3, 16, 0xE0,
        0x10000, 0x1FFFFF, 4, 19, 0xF0,
        0x200000, 0x3FFFFFF, 5, 26, 0xF8,
        0x4000000, 0x7FFFFFFF, 6, 31, 0xFC,
    };
    static char result[7];
    int i, j, k;

    memset(result, 0, 7);
    for (i = 0; i < 6 * CS; i += CS) {
        if (conversion[i] <= c && conversion[i + 1] >= c) {
            /* we have the right conversion */
            j = conversion[i + 3];
            k = conversion[i + 2] - 1;
            while (j > 8) {
                /* convert 6 bits at a time */
                result[k--] = (char) (0x80 | (c & 0x3F));
                c >>= 6;
                j -= 8;
            }
            result[0] = (char) (conversion[i + 4] | c);
            result[conversion[i + 2]] = 0;
            return result;
        }
    }
    return result;
#undef CS
}

/* convert WideString to UTF-8 */
GString cvt_ws_to_utf8(const unsigned short *wss)
{
	if( !wss )
		return "";

	unsigned char *ws = (unsigned char *)wss;
    GString s;
    unsigned long u;
    unsigned w1, w2;


    if (ws == NULL)
        return NULL;
    if (widechar == NO_WC_STANDARD) {
        if (*ws == 0 && ws[1] == 0)
            return NULL;
        /* do we have a byte order mark of 0xFEFF? */
        if (*ws == 0xFE && ws[1] == 0xFF)
            widechar = UTF16LE;
        else if (*ws == 0xFF && ws[1] == 0xFE)
            widechar = UTF16BE;
        /* is the first char printable and regular ASCII? */
        else if (*ws == 0 && isprint(ws[1]))
            widechar = UTF16LE;
        else if (ws[1] == 0 && isprint(*ws))
            widechar = UTF16BE;
        else if (isprint(*ws) && isprint(ws[1]))
            widechar = UTF8;
    }
    if (widechar == NO_WC_STANDARD)
        return NULL;
    if (widechar == UTF8) {
        return GString((char *) ws);
    }
    if (*ws > 0xFD && ws[1] > 0xFD)
        ws += 2;
    do {
        /* find a character and convert it */
        if (widechar == UTF16LE) {
            /* little-endian */
            w1 = ws[0];
            w1 <<= 8;
            w1 |= ws[1];
        } else if (widechar == UTF16BE) {
            /* big-endian */
            w1 = ws[1];
            w1 <<= 8;
            w1 |= ws[0];
        }
        if (w1 < 0xD800 || w1 > 0xDFFF) {
            /* two-byte character */
            u = w1;
            ws += 2;
        } else {
            /* four-byte character */
            if (widechar == UTF16LE) {
                /* little-endian */
                w2 = ws[2];
                w2 <<= 8;
                w2 |= ws[3];
            } else {
                /* big-endian */
                w2 = ws[3];
                w2 <<= 8;
                w2 |= ws[2];
            }
            if (w2 >= 0xDC00 && w2 <= 0xDFFF) {
                /* convert four-byte character into Unicode */
                u = (w1 & 0x3FF);
                u <<= 10;
                u |= (w2 & 0x3FF);
                u += 0x10000;
                ws += 4;
            } else {
                /* error */
                return NULL;
            }
        }
        GString cval = cvt_wc_to_utf8(u);
        s += cval;

    } while (u > 0);
   // s = (char*)xrealloc(s, strlen(s) + 1);

    return s;
}


bool read_file_data(const char* filename, const char* mode, DArray<char> &data)
{
	FILE *fp;
	if( fp = fopen(filename, mode) )
	{
		fseek(fp, 0, SEEK_END);
		int len = ftell(fp);
		fseek(fp, 0, SEEK_SET);
		
		data.resize(0, len-1);
		fread(data, len, 1, fp);

		fclose(fp);
		return 1;
	}
	else
		return 0;
}


GURL GetURLFromP3PHeader(GString &p3pheader, const GURL &sourceURL)
{
TRY
{
	GURL url;
	if( p3pheader.length() )
	{
		int pos = p3pheader.search("policyref=");
		if( pos >= 0 )
		{
			pos = p3pheader.search("\"", pos);
			if( pos >= 0 )
			{
				int endpos = p3pheader.search("\"", pos+1);
				if( endpos > pos )
				{
					GString strurl = p3pheader.substr(pos+1, endpos-pos-1);
					url = GURL(strurl, sourceURL);
					return url;
				}
			}
		}
	}
}
CATCH(ex)
{
}
ENDCATCH;
return GURL();
}

bool IsAllWhiteSpace(const char* str)
{
	if( str )
	{
		int len = strlen(str);
		for(int i=0; i<len; i++)
		{
			if( !isspace(str[i]) )
				return false;
		}
		return true;
	}
	return false;
}


GString SeparateNameAndURL(GURL &url)
{
	if( url.is_empty() )
		return "";
	GString strurl = url;
	int poundpos = strurl.search('#');
	if( poundpos >= 0 )
	{
		url = strurl.substr(0, poundpos);
		return strurl.substr(poundpos+1, -1);
	}
	return "";
}


int FileCopy(const char* file_in, const char* file_out)
{
	FILE *fin, *fout;

	fin = fopen(file_in, "rb" );
	fout = fopen(file_out, "wb" );

	if( fin )
	{
		if( fout )
		{
			fseek(fin, 0, SEEK_END);
			int length = ftell(fin);
			fseek(fin, 0, SEEK_SET);
			for( int i=0; i<length; i++)
			{
				char c;
				fread(&c, 1, 1, fin);
				fwrite(&c, 1, 1, fout);
			}

			fclose(fout);
		}
		else
			return -2; // Failed to create output file

		fclose(fin);
	}
	else
		return -1; // Failed to open input file

	return 1; // OK

}


int cvt_hotkey_mod(int hotkey_mod)
{
	int code=0;

	switch( g_p3p_preferences.hotkey_mod )
	{
		case 1: code = HOTKEYF_CONTROL; break;

		case 3: code = HOTKEYF_CONTROL | HOTKEYF_ALT; break;

		case 5: code = HOTKEYF_CONTROL | HOTKEYF_SHIFT; break;
			
		case 7: code = HOTKEYF_CONTROL | HOTKEYF_ALT | HOTKEYF_SHIFT; break;
	}

	return code;
}


