// IconDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "IconDialog.h"
#include "commctrl.h"
#include "PrivacySettingsDialog.h"
#include "CookieSettingsDialog.h"
#include "OtherSettingsDialog.h"
#include "OverrideSettingsDialog.h"
#include "FullPolicyDialog.h"
#include "PolicySummaryDialog.h"
#include "Globals.h"
#include "PolicyHandler.h"
#include "ViewPolicyDialog.h"
#include "EmbeddedContentDialog.h"
#include "URLListDialog.h"
#include "P3PPreferences.h"
#include "CookieHistoryDialog.h"
#include "OverrideSitesDialog.h"
#include "SummaryHTML.h"


#define MATCH_BIRD								0
#define MATCH_NOTHIRDPARTY_BIRD					1
#define MACTH_BIRD_BLOCK_COOKIES				2
#define MATCH_BIRD_NOTHIRDPARTY_BLOCK_COOKIES	3
#define UNKNOWN_BIRD							4
#define UNKNOWN_BIRD_BLOCK_COOKIES				5
#define UNMATCH_BIRD							6
#define UNMATCH_BIRD_BLOCK_COOKIES				7
#define DISABLE_BIRD							8
#define NO_BIRD									9

//#define TOUR_URL	"http://privacy.att.net/tour/1_0_beta/tour.html"
#define TOUR_URL	"http://www.privacybird.com/tour/1_1_beta/tour.html"
#define DEFAULTTOOLTIPTEXT "Click here to use AT&T Privacy Bird" 


//////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CIconDialog dialog

class DisableWindows
{
	friend CIconDialog;
	CIconDialog &dlg;

	DisableWindows(CIconDialog &d): dlg(d)
	{
		::EnableWindow(dlg.m_pParent->m_hwndBrowser, FALSE);
		::EnableWindow(dlg.m_hWnd, FALSE);
	}
	~DisableWindows()
	{
		::EnableWindow(dlg.m_pParent->m_hwndBrowser, TRUE);
		::EnableWindow(dlg.m_hWnd, TRUE);
	}
};


CIconDialog::CIconDialog(CP3PObject* pParent) : 
	m_pParent(pParent), bBusy(false), tooltip(0), bMoving(false)
{
	// Store the pointer to the CP3PObject class
	char *tname = tempnam(g_dllpath, "summary");
	if( tname )
	{
		summaryfilename = tname;
	}
	else
	{
		summaryfilename += g_dllpath+"\\summary";
	}
	summaryfilename += ".html";
		
}


CIconDialog::~CIconDialog()
{
	unlink(summaryfilename);

}


LRESULT CIconDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{
	// Move the Code Window to its rectangle
	SetProp(m_hWnd, "P3PMainWindow", (HANDLE)0xFACEFACE);
	RECT rc;
	m_pParent->GetCodeWindowRect(&rc);
	/*MoveWindow(rc.left, rc.top,
		   (rc.right-rc.left), 
		   (rc.bottom-rc.top), true);*/
	//SetWindowPos(NULL, rc.left, rc.top, 0, 0, SWP_NOSIZE);
#ifdef COOKIES
	tooltip = AddToolTipToControl(m_hWnd, _T("Click here to use Privacy Companion"));
#else
	tooltip = AddToolTipToControl(m_hWnd, _T(DEFAULTTOOLTIPTEXT));
#endif

	SetToolTipText("Hello how are you!!!");

	HWND animate = GetDlgItem(IDC_ANIMATE);
	SendMessage(animate, ACM_OPEN, (_WIN32_IE >= 0x0400)?(WPARAM)hinst:0, (LPARAM)MAKEINTRESOURCE(IDR_P3P_ANIM));

	if( animate )
	{
		::GetWindowRect(animate, &rc);
		SetWindowPos(0, 0, 0, rc.right-rc.left+1, rc.bottom-rc.top+1, SWP_NOZORDER|SWP_NOMOVE);
	}

	
	if( !g_enabled )
	{
		Show();
		SetImageDisable();
	}
	else
	{
		Hide();
		SetImageUnknown();
	}
 
	///SetHotkey here
	//SendMessage(WM_SETHOTKEY, (WPARAM) MAKEWORD(VK_F12, HOTKEYF_CONTROL| HOTKEYF_ALT)  );
	SendMessage(WM_SETHOTKEY, (WPARAM) MAKEWORD(g_p3p_preferences.hotkey_key, cvt_hotkey_mod(g_p3p_preferences.hotkey_mod) ) );	

	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT CIconDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT CIconDialog::OnRButtonDown(BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
	return OnLButtonDown(fDoubleClick, x, y, keyFlags);
}


LRESULT CIconDialog::OnLButtonDown(BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
	if( bMoving )
	{
		bMoving = false;
		g_onTitleBar = false;
		GetCursorPos(&g_Position);
		ReleaseCapture();
		g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
		SendCommandToAllP3Ps(ID_MOVED, true);

		return 0;
	}
	::SetFocus(this->m_pParent->m_hwndBrowser);

	if( !IsWindowVisible() || !IsWindowEnabled() )
		return 1;
	
	HMENU menu=0;
	HMENU popup=0;
	if( g_enabled )
	{
#ifdef COOKIES
		menu = LoadMenu(hinst, MAKEINTRESOURCE(IDR_ENABLED_MENU));
#else
		menu = LoadMenu(hinst, MAKEINTRESOURCE(IDR_NOCOOKIE_MENU));
#endif
		popup = GetSubMenu(menu, 0);
		GString proto = m_pParent->get_locationURL().protocol();
		if( bBusy || !(proto == "http" || proto == "https"))
		{
			EnableMenuItem(popup, 0, MF_BYPOSITION| MF_GRAYED);
		}
		else
		{
			EnableMenuItem(popup, 0, MF_BYPOSITION| MF_ENABLED);

			P3PMatchInfo &matchinfo = m_pParent->GetMatchInfo();
			Result result = matchinfo.GetMainResult();

			if( !result.DiscURI.length())
			{
				EnableMenuItem(popup, ID_FULL_POLICY, MF_BYCOMMAND| MF_GRAYED);
			}
			else
			{
				EnableMenuItem(popup, ID_FULL_POLICY, MF_BYCOMMAND| MF_ENABLED);
			}
			if( !result.OptURI.length())
			{
				EnableMenuItem(popup, ID_OPTIN_OPTOUT_INFO, MF_BYCOMMAND| MF_GRAYED);
			}
			else
			{
				EnableMenuItem(popup, ID_OPTIN_OPTOUT_INFO, MF_BYCOMMAND| MF_ENABLED);
			}

			if( result.Match != Result::UNKNOWN )
			{
				EnableMenuItem(popup, ID_POLICY_SUMMARY, MF_BYCOMMAND| MF_ENABLED);
				EnableMenuItem(popup, ID_VIEW_SOURCE, MF_BYCOMMAND| MF_ENABLED);
			}
			else
			{
				EnableMenuItem(popup, ID_POLICY_SUMMARY, MF_BYCOMMAND| MF_GRAYED);
				EnableMenuItem(popup, ID_VIEW_SOURCE, MF_BYCOMMAND| MF_GRAYED);
			}

			if( g_onTitleBar )
			{
				EnableMenuItem(popup, ID_SETONTITLEBAR, MF_BYCOMMAND| MF_GRAYED);
			}
			else
			{
				EnableMenuItem(popup, ID_SETONTITLEBAR, MF_BYCOMMAND|MF_ENABLED );
			}


		}
	}
	else
	{
		menu = LoadMenu(hinst, MAKEINTRESOURCE(IDR_DISABLED_MENU));
		popup = GetSubMenu(menu, 0);
	}

	RECT crc;
	this->GetWindowRect(&crc);

	TPMPARAMS tpm = { sizeof(TPMPARAMS) };
	tpm.rcExclude = crc;

	POINT p = {x, y};
	ClientToScreen(&p);

	TrackPopupMenuEx(popup, TPM_TOPALIGN|TPM_VERTICAL, crc.left, crc.bottom, this->m_hWnd, &tpm);
	
	return 1;
}

void CIconDialog::Reposition(HWND parent)
{
	if( parent && g_onTitleBar )
	{

		RECT rc;
		::GetWindowRect(parent, &rc);
		int h = GetSystemMetrics(SM_CYCAPTION);
		int w = h;
		int off = 0;
		if( h>20 )
		{
			off = (h-20)/2;
			h = 20;
		}

		RECT crc;
		this->GetWindowRect(&crc);
		int frame = GetSystemMetrics(SM_CYFRAME);
		SetWindowPos(NULL, rc.right-(4*w+crc.right-crc.left), rc.top+frame+off, crc.right-crc.left, h, SWP_NOZORDER);
		::SetFocus(this->m_pParent->m_hwndBrowser);
	}
	else
	{
		int h = GetSystemMetrics(SM_CYCAPTION);
		int w = h;
		int off = 0;
		if( h>20 )
		{
			off = (h-20)/2;
			h = 20;
		}

		RECT crc;
		this->GetWindowRect(&crc);
		int frame = GetSystemMetrics(SM_CYFRAME);
		SetWindowPos(NULL, g_Position.x, g_Position.y, crc.right-crc.left, h, SWP_NOZORDER);
	}
}


BOOL CALLBACK AboutProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
)
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			
		}break;

	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDOK:
				EndDialog(hwndDlg, IDOK);
			}
		}
	}
	return FALSE;
}
 

LRESULT CIconDialog::OnAbout(WORD, WORD, HWND, BOOL&)
{
	::EnableWindow(this->m_pParent->m_hwndBrowser, FALSE);
	::DialogBox(hinst, MAKEINTRESOURCE(IDD_ABOUT), this->m_hWnd, AboutProc);
	::EnableWindow(this->m_pParent->m_hwndBrowser, TRUE);
	return 1;
}

LRESULT CIconDialog::OnChangedPreferences(WORD, WORD, HWND, BOOL&)
{
	g_p3p_preferences.InitializationLoad(g_dllpath+INITIALIZATION_FILE);
	g_p3p_preferences.GetCurPreferenceFile(true);

	return 1;
}


LRESULT CIconDialog::OnChangedCookieSettings(WORD, WORD, HWND, BOOL&)
{
	g_p3p_preferences.CookieLoad(g_dllpath+COOKIE_FILE);

	return 1;
}


LRESULT CIconDialog::OnChangedInit(WORD, WORD, HWND, BOOL&)
{
	g_p3p_preferences.InitializationLoad(g_dllpath+INITIALIZATION_FILE);

	return 1;
}


LRESULT CIconDialog::OnChangedNoPromptSites(WORD, WORD, HWND, BOOL&)
{
	g_p3p_preferences.NoPromptSitesLoad(g_dllpath+NO_PROMPT_SITES_FILE);

	return 1;
}


LRESULT CIconDialog::OnP3PEnable(WORD, WORD, HWND, BOOL&)
{
	g_enabled = true;
	SetImageUnknown();

	if( CM_EnableIDcide )
		CM_EnableIDcide(g_enabled);

	m_pParent->EvaluatePolicy(NULL, false);
	return 1;
}

LRESULT CIconDialog::OnP3PDisable(WORD, WORD, HWND, BOOL&)
{
	g_enabled = false;
	SetImageDisable();

	if( CM_EnableIDcide )
		CM_EnableIDcide(g_enabled);
	
	return 1;
}


LRESULT CIconDialog::OnEnable(WORD lParam, WORD wParam, HWND hwnd, BOOL& result)
{

	g_enabled = true;
	g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
	SendCommandToAllP3Ps(ID_P3PENABLE, true);

	return 1;
}

LRESULT CIconDialog::OnDisable(WORD lParam, WORD wParam, HWND hwnd, BOOL& result)
{
	g_enabled = false;
	g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
	SendCommandToAllP3Ps(ID_P3PDISABLE, true);
	return 1;
}

LRESULT CIconDialog::OnPrivacySettings(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		CPrivacySettingsDialog sd;
		if( sd.DoModal() == IDOK )
			SendCommandToAllP3Ps(ID_P3PENABLE, true);
	}
	return 1;
}

LRESULT CIconDialog::OnCookieSettings(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		CCookieSettingsDialog sd;
		sd.DoModal();
	}
	return 1;
}

LRESULT CIconDialog::OnNoPromptSites(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		GList<GURL> url_list = g_p3p_preferences.GetNoPromptSiteList();
		
		const char* window_title = "No-prompt web sites";
		const char* heading_text = "You have asked not to be prompted when "
							"submitting forms to the following web sites "
							"regardless of whether the site's privacy policy matches "
							"your preferences. To remove a site from this no-prompt " 
							"list, select the site and click the Delete button.";
		CURLListDialog uld(url_list, window_title, heading_text);

		if( (uld.DoModal() == IDOK) && (url_list.size()!= g_p3p_preferences.GetNoPromptSiteListSize()) )
		{
			g_p3p_preferences.SetNoPromptSiteList(url_list); 
			SendCommandToAllP3Ps(ID_CHANGED_NOPROMPTSITES);
		}
	}
	return 1;
}

LRESULT CIconDialog::OnOtherSettings(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		COtherSettingsDialog sd;
		sd.DoModal();
	}
	return 1;
}

LRESULT CIconDialog::OnOverrideSettings(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		COverrideSettingsDialog sd(GetLocationURL());
		sd.DoModal();
	}
	return 1;
}

LRESULT CIconDialog::OnFullPolicy(WORD, WORD, HWND, BOOL&)
{
	HINSTANCE inst;
	P3PMatchInfo &info = m_pParent->GetMatchInfo();
	Result result = info.GetMainResult();
	if( result.DiscURI.length() )
	{
		GURL DiscURI(result.DiscURI, result.appliedPolicyURL);
		 inst = ShellExecute(NULL, "open", "IEXPLORE.EXE", DiscURI, "", SW_SHOWNORMAL );
	}
	
	return 1;
}

LRESULT CIconDialog::OnOptInOptOut(WORD, WORD, HWND, BOOL&)
{
	HINSTANCE inst;
	P3PMatchInfo &info = m_pParent->GetMatchInfo();
	Result result = info.GetMainResult();
	if( result.OptURI.length() )
	{
		GURL OptURI(result.OptURI, result.appliedPolicyURL);
		 inst = ShellExecute(NULL, "open", "IEXPLORE.EXE", OptURI, "", SW_SHOWNORMAL );
	}
	
	return 1;
}

LRESULT CIconDialog::OnPolicySummary(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		P3PMatchInfo &info = m_pParent->GetMatchInfo();
		Result result = info.GetMainResult();
		CPolicySummaryDialog sd(result);
		sd.DoModal();
	}
	return 1;
}

void CIconDialog::SetImageMatch3rdPartyNomatch()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(MATCH_NOTHIRDPARTY_BIRD, MATCH_NOTHIRDPARTY_BIRD));
	SetToolTipText();
}

void CIconDialog::SetImageMatch3rdPartyNomatchBlockedCookies()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(MATCH_BIRD_NOTHIRDPARTY_BLOCK_COOKIES, MATCH_BIRD_NOTHIRDPARTY_BLOCK_COOKIES));
}


void CIconDialog::SetImageBusy()
{
	bBusy = true;
	if( !g_enabled || g_p3p_preferences.user_prefs & P3PPreferences::DISABLE_ANIMATION)
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, -1, MAKELONG(DISABLE_BIRD+1, -1));
	SetToolTipText(DEFAULTTOOLTIPTEXT);
}

void CIconDialog::SetImageUnknown()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(UNKNOWN_BIRD, UNKNOWN_BIRD));
	SetToolTipText("Valid policy not found");
}

void CIconDialog::SetImageUnknownBlockedCookies()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(UNKNOWN_BIRD_BLOCK_COOKIES, UNKNOWN_BIRD_BLOCK_COOKIES));
}


void CIconDialog::SetImageMatch()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(MATCH_BIRD, MATCH_BIRD));
	SetToolTipText();

}

void CIconDialog::SetImageMatchBlockedCookies()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(MACTH_BIRD_BLOCK_COOKIES, MACTH_BIRD_BLOCK_COOKIES));
}

void CIconDialog::SetImageNoMatch()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(UNMATCH_BIRD, UNMATCH_BIRD));
	SetToolTipText();
}

void CIconDialog::SetImageNoMatchBlockedCookies()
{
	bBusy = false;
	if( !g_enabled )
		return;
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(UNMATCH_BIRD_BLOCK_COOKIES, UNMATCH_BIRD_BLOCK_COOKIES));
}

void CIconDialog::SetImageDisable()
{
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(DISABLE_BIRD, DISABLE_BIRD));
	SetToolTipText(DEFAULTTOOLTIPTEXT);
}

void CIconDialog::SetImageNoBird()
{
	//Show();
	::PostMessage(GetDlgItem(IDC_ANIMATE), ACM_PLAY, 1, MAKELONG(NO_BIRD, NO_BIRD));
}

GURL CIconDialog::GetLocationURL()
{
	return m_pParent->get_locationURL();
}


void CIconDialog::Hide()
{
	ShowWindow(SW_HIDE);
}

void CIconDialog::Show()
{
	ShowWindow(SW_SHOW);
}
bool CIconDialog::isVisible()
{
	return IsWindowVisible()?true:false;
}

LRESULT CIconDialog::OnViewPolicy(WORD, WORD, HWND, BOOL&)
{
	P3PMatchInfo &matchinfo = m_pParent->GetMatchInfo();
	GURL purl = matchinfo.GetAppliedMainPolicyURL();
	if( purl.is_empty() )
		return FALSE;

	//Show Policy in IE
	GString localpath = g_policy_handler.GetLocalPathFromCache(purl);
	if( localpath.length() > 0 )
	{
		HINSTANCE inst;
		inst = ShellExecute(NULL, "open", "IEXPLORE.EXE", purl, "", SW_SHOWNORMAL );
	/*	DisableWindows dw(*this);
		CViewPolicyDialog sd(purl, localpath);
		sd.DoModal();*/
	}
	else
	{
		MessageBox("File Could not be downloaded", "File Download problem"+purl, MB_OK+MB_ICONSTOP);
	}
	

	return TRUE;

	/*

	char *data = g_policy_handler.GetURL(purl, false, false);

	{
		DisableWindows dw(*this);
		CViewPolicyDialog dlg(purl, data);
		dlg.DoModal();
	}
	
	if( data )
		delete data;
	
	return TRUE;
	*/
}

void CIconDialog::SaveSummary(GString &summary)
{
	FILE *fp;
	if( fp = fopen(summaryfilename, "wb") )
	{
		fwrite(summary, summary.length(), 1, fp);
		fclose(fp);
	}
}


LRESULT CIconDialog::OnEmbeddedContent(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		P3PMatchInfo &matchinfo = m_pParent->GetMatchInfo();
		CEmbeddedContentDialog dlg(matchinfo);
		dlg.DoModal();
	}
	return TRUE;
}



LRESULT CIconDialog::OnHelp(WORD, WORD, HWND, BOOL&)
{
	return HtmlHelp( NULL, g_dllpath+"\\p3pclient.chm::/help.html",
				HH_DISPLAY_TOPIC, 0)  != NULL;

}


LRESULT CIconDialog::OnCookieStatus(WORD, WORD, HWND, BOOL&)
{
	P3PMatchInfo &matchinfo = m_pParent->GetMatchInfo();
	int cookiesdetected, cookiesblocked, othercookiesdetected, othercookiesblocked;
	matchinfo.GetCookieInfo(cookiesdetected, cookiesblocked, othercookiesdetected, othercookiesblocked);
	GString buffer;
	buffer.format( "Cookies from \"%s\" detected: %d   \n"
					"Cookies from \"%s\" blocked: %d    \n"
					"Cookies from other sites detected: %d   \n"
					"Cookies from other sites blocked: %d    ",
					(const char*)m_pParent->locationURL, cookiesdetected, 
					(const char*)m_pParent->locationURL, cookiesblocked, 
					othercookiesdetected, othercookiesblocked);
	::MessageBox(m_pParent->m_hwndBrowser, buffer, "Cookie Report", MB_ICONEXCLAMATION|MB_OK);
	return TRUE;
}


LRESULT CIconDialog::OnCookieHistory(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		CCookieHistoryDialog dlg;
		dlg.DoModal();
	}

	return TRUE;
}


LRESULT CIconDialog::OnTutorial(WORD, WORD, HWND, BOOL&)
{
	HINSTANCE inst;
	inst = ShellExecute(NULL, "open", "IEXPLORE.EXE", TOUR_URL /*g_dllpath+TUTORIAL_FILE*/, "", SW_SHOWNORMAL );
	return 1;
}

LRESULT CIconDialog::OnClearCache(WORD, WORD, HWND, BOOL&)
{
	g_policy_handler.ClearCache();
	return 1;
}

LRESULT CIconDialog::OnCookieOverrideSites(WORD, WORD, HWND, BOOL&)
{
	{
		DisableWindows dw(*this);
		COverrideSitesDialog osd;
		osd.DoModal();
	}
	return 1;
}


LRESULT CIconDialog::OnSetCursor(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// TODO : Add Code for message handler. Call DefWindowProc if necessary.
	if( bBusy )
	{
		SetCursor(LoadCursor(NULL, IDC_WAIT));
		return TRUE;
	}
	return 0;
}

LRESULT CIconDialog::OnLButtonDblClk(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	::SetFocus(this->m_pParent->m_hwndBrowser);
	return 1;
}
/*
LRESULT CIconDialog::OnRButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	::SetFocus(this->m_pParent->m_hwndBrowser);
	return 1;
}
*/
LRESULT CIconDialog::OnRButtonDblClk(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	::SetFocus(this->m_pParent->m_hwndBrowser);
	return 1;
}

LRESULT CIconDialog::OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	::SetFocus(this->m_pParent->m_hwndBrowser);
	return 0;
}


LRESULT CIconDialog::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if( wParam == SC_HOTKEY )
		PostMessage(WM_LBUTTONDOWN);
	return 1;
}

LRESULT CIconDialog::OnSetToolTipText(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{

	::SetToolTipText(tooltip, (char*)wParam); 
	return 1;
}

LRESULT CIconDialog::OnMove(WORD, WORD, HWND, BOOL&)
{
	bMoving = true;
	POINT p;
	GetCursorPos(&p);

	{
		SetWindowPos(NULL, p.x, p.y, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
	}
	SetCapture();

return 1;
}

LRESULT CIconDialog::OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// TODO : Add Code for message handler. Call DefWindowProc if necessary.
	if( bMoving )
	{
		POINT p;
	GetCursorPos(&p);
	SetWindowPos(NULL, p.x, p.y, 0, 0, SWP_NOZORDER|SWP_NOSIZE);

	}
	return 0;
}

LRESULT CIconDialog::OnSetOnTitleBar(WORD, WORD, HWND, BOOL&)
{
	g_onTitleBar = true;
	Reposition(GetParent());
	g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
	SendCommandToAllP3Ps(ID_MOVED, true);
	return 0;
}

LRESULT CIconDialog::OnMoved(WORD, WORD, HWND, BOOL&)
{
	g_p3p_preferences.InitializationLoad(g_dllpath+INITIALIZATION_FILE);
	Reposition(GetParent());
	return 0;
}

void CIconDialog::SetToolTipText()
{
	P3PMatchInfo &info = m_pParent->GetMatchInfo();
	Result result = info.GetMainResult();
	GString shortsummary;
	SummaryHTML::PrepareShortSummary(result, shortsummary);
	shortsummary = AddReturns(shortsummary);
	strncpy(tooltiptext, shortsummary, sizeof(tooltiptext));
	SetToolTipText((char*)(const char*)tooltiptext);
}



