#ifndef __ICONDLG_H_
#define __ICONDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "GString.h"
#include "GURL.h"
#include "GContainer.h"
#include "Globals.h"

#include "P3PEvaluator.h"

class CP3PObject;

/////////////////////////////////////////////////////////////////////////////
// CIconDialog dialog

class CIconDialog : public CAxDialogImpl<CIconDialog>
{
// Construction
public:
	CIconDialog(CP3PObject *pParent);   // standard constructor

	~CIconDialog();

	CP3PObject *m_pParent;
	enum { IDD = IDD_ICONDIALOG };
	void Reposition(HWND parent);

	void SetImageUnknown();
	void SetImageMatch();
	void SetImageNoMatch();
	void SetImageBusy();
	void SetImageMatch3rdPartyNomatch();
	void SetImageDisable();
	void SetImageMatch3rdPartyNomatchBlockedCookies();
	void SetImageUnknownBlockedCookies();
	void SetImageMatchBlockedCookies();
	void SetImageNoMatchBlockedCookies();
	void SetImageNoBird();

	void Hide();
	void Show();
	bool isVisible();
	
	GURL GetLocationURL();
	void SaveSummary(GString &summary);
	GString GetSummaryFilename(){ return summaryfilename; }

BEGIN_MSG_MAP(CIconDialog)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	MESSAGE_HANDLER(ID_SETTOOLTIPTEXT, OnSetToolTipText)
	COMMAND_ID_HANDLER(ID_ABOUT, OnAbout)
	COMMAND_ID_HANDLER(ID_ENABLE, OnEnable)
	COMMAND_ID_HANDLER(ID_DISABLE, OnDisable)
	COMMAND_ID_HANDLER(ID_CHANGESETTINGS_PRIVACY, OnPrivacySettings)
	COMMAND_ID_HANDLER(ID_CHANGESETTINGS_COOKIES, OnCookieSettings)
	COMMAND_ID_HANDLER(ID_CHANGESETTINGS_NOPROMPTSITES, OnNoPromptSites)
	COMMAND_ID_HANDLER(ID_CHANGESETTINGS_OTHER, OnOtherSettings)
	COMMAND_ID_HANDLER(ID_OVERRIDE_COOKIESETTINGS, OnOverrideSettings)
	COMMAND_ID_HANDLER(ID_FULL_POLICY, OnFullPolicy)
	COMMAND_ID_HANDLER(ID_OPTIN_OPTOUT_INFO, OnOptInOptOut)
	COMMAND_ID_HANDLER(ID_POLICY_SUMMARY, OnPolicySummary)
	COMMAND_ID_HANDLER(ID_VIEW_SOURCE, OnViewPolicy)
	COMMAND_ID_HANDLER(ID_EMBEDDED_CONTENT, OnEmbeddedContent)
	COMMAND_ID_HANDLER(ID_HELP, OnHelp)
	COMMAND_ID_HANDLER(ID_COOKIE_STATUS, OnCookieStatus)
	COMMAND_ID_HANDLER(ID_COOKIE_HISTORY, OnCookieHistory)
	COMMAND_ID_HANDLER(ID_TUTORIAL, OnTutorial)
	COMMAND_ID_HANDLER(ID_CLEAR_CACHE, OnClearCache)
	COMMAND_ID_HANDLER(ID_P3PENABLE, OnP3PEnable)
	COMMAND_ID_HANDLER(ID_P3PDISABLE, OnP3PDisable)
	COMMAND_ID_HANDLER(ID_CHANGED_PREFERENCES, OnChangedPreferences)
	COMMAND_ID_HANDLER(ID_CHANGED_COOKIE_SETTINGS, OnChangedCookieSettings)
	COMMAND_ID_HANDLER(ID_CHANGED_INIT, OnChangedInit)
	COMMAND_ID_HANDLER(ID_CHANGED_NOPROMPTSITES, OnChangedNoPromptSites)

	COMMAND_ID_HANDLER(IDC_OVERRIDE_SITES_LIST, OnCookieOverrideSites)
	COMMAND_ID_HANDLER(ID_MOVE, OnMove)
	COMMAND_ID_HANDLER(ID_MOVED, OnMoved)
	COMMAND_ID_HANDLER(ID_SETONTITLEBAR, OnSetOnTitleBar)
	
	MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
	MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnLButtonDblClk)
	MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRButtonDown)
	MESSAGE_HANDLER(WM_RBUTTONDBLCLK, OnRButtonDblClk)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_SYSCOMMAND, OnSysCommand)
	//MESSAGE_HANDLER(WM_HOTKEY, OnHotKey)
	MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnLButtonDown(BOOL fDoubleClick, int x, int y, UINT keyFlags);
	LRESULT OnRButtonDown(BOOL fDoubleClick, int x, int y, UINT keyFlags);
	
	LRESULT OnSetToolTipText(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnAbout(WORD, WORD, HWND, BOOL&);
	LRESULT OnEnable(WORD, WORD, HWND, BOOL&);
	LRESULT OnDisable(WORD, WORD, HWND, BOOL&);
	LRESULT OnMove(WORD, WORD, HWND, BOOL&);
	LRESULT OnMoved(WORD, WORD, HWND, BOOL&);
	
	LRESULT OnSetOnTitleBar(WORD, WORD, HWND, BOOL&);
	LRESULT OnPrivacySettings(WORD, WORD, HWND, BOOL&);
	LRESULT OnCookieSettings(WORD, WORD, HWND, BOOL&);
	LRESULT OnNoPromptSites(WORD, WORD, HWND, BOOL&);	
	LRESULT OnOtherSettings(WORD, WORD, HWND, BOOL&);	
	LRESULT OnOverrideSettings(WORD, WORD, HWND, BOOL&);	
	LRESULT OnFullPolicy(WORD, WORD, HWND, BOOL&);	
	LRESULT OnOptInOptOut(WORD, WORD, HWND, BOOL&);	
	LRESULT OnPolicySummary(WORD, WORD, HWND, BOOL&);
	LRESULT OnViewPolicy(WORD, WORD, HWND, BOOL&);
	LRESULT OnEmbeddedContent(WORD, WORD, HWND, BOOL&);
	LRESULT OnHelp(WORD, WORD, HWND, BOOL&);
	LRESULT OnCookieStatus(WORD, WORD, HWND, BOOL&);
	LRESULT OnCookieHistory(WORD, WORD, HWND, BOOL&);
	LRESULT OnTutorial(WORD, WORD, HWND, BOOL&);
	LRESULT OnClearCache(WORD, WORD, HWND, BOOL&);
	LRESULT OnP3PEnable(WORD, WORD, HWND, BOOL&);
	LRESULT OnP3PDisable(WORD, WORD, HWND, BOOL&);
	LRESULT OnChangedPreferences(WORD, WORD, HWND, BOOL&);
	LRESULT OnChangedCookieSettings(WORD, WORD, HWND, BOOL&);
	LRESULT OnChangedInit(WORD, WORD, HWND, BOOL&);
	LRESULT OnChangedNoPromptSites(WORD, WORD, HWND, BOOL&);
	LRESULT OnCookieOverrideSites(WORD, WORD, HWND, BOOL&);
	LRESULT OnSetCursor(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	

private:
	
	GString summaryfilename;
	bool bBusy;
	bool bMoving;

	HWND tooltip;
	char tooltiptext[10000];
	void SetToolTipText(char *text) { PostMessage(ID_SETTOOLTIPTEXT, (WPARAM)text); }
	void SetToolTipText();

	LRESULT OnLButtonDblClk(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	
	LRESULT OnRButtonDblClk(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

};


#endif 