// OtherSettingsDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "OtherSettingsDialog.h"
#include "P3PPreferences.h"
#include "commctrl.h"
#include "globals.h"


/////////////////////////////////////////////////////////////////////////////
// COtherSettingsDialog dialog

static DWORD help_array[] = {
							IDC_GROUP_SOUNDS, IDH_GROUP_SOUNDS,
							IDC_DISABLE_SOUNDS, IDH_DISABLE_SOUNDS,
							IDC_UNKNOWN_POLICY, IDH_UNKNOWN_POLICY,
							IDC_UNMATCHED_POLICY, IDH_UNMATCHED_POLICY,
							IDC_MATCHED_POLICY, IDH_MATCHED_POLICY,
							0,0
						};



COtherSettingsDialog::COtherSettingsDialog() 
{
	// Store the pointer to the CP3PObject class
}


COtherSettingsDialog::~COtherSettingsDialog()
{
}


LRESULT COtherSettingsDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{

	if( g_p3p_preferences.check_upgrade ) 
		CheckDlgButton(IDC_AUTOUPGRADE, BST_CHECKED);
	else
		CheckDlgButton(IDC_AUTOUPGRADE, BST_UNCHECKED);
	if( g_p3p_preferences.user_prefs & P3PPreferences::DISABLE_ANIMATION )
		CheckDlgButton(IDC_DISABLE_ANIMATION, BST_CHECKED);
	else
		CheckDlgButton(IDC_DISABLE_ANIMATION, BST_UNCHECKED);

	//disable popup windows
	if( g_p3p_preferences.user_prefs & P3PPreferences::DISABLE_POPUP_WINDOWS )
		CheckDlgButton(IDC_DISABLE_POPUPS, BST_CHECKED);
	else
		CheckDlgButton(IDC_DISABLE_POPUPS, BST_UNCHECKED);

	if( !g_p3p_preferences.enable_sounds )
	{
		CheckDlgButton(IDC_DISABLE_SOUNDS, BST_CHECKED);
		::EnableWindow(GetDlgItem(IDC_UNKNOWN_POLICY), FALSE);
		::EnableWindow(GetDlgItem(IDC_MATCHED_POLICY), FALSE);
		::EnableWindow(GetDlgItem(IDC_UNMATCHED_POLICY), FALSE);
		::EnableWindow(GetDlgItem(IDC_NEW_POLICY), FALSE);

	}
	else
	{
		CheckDlgButton(IDC_DISABLE_SOUNDS, BST_UNCHECKED);
		if( g_p3p_preferences.enable_sounds & P3PPreferences::ENABLE_SOUND_UNKNOWN)
			CheckDlgButton(IDC_UNKNOWN_POLICY, BST_UNCHECKED);
		else
			CheckDlgButton(IDC_UNKNOWN_POLICY, BST_CHECKED);

		if( g_p3p_preferences.enable_sounds & P3PPreferences::ENABLE_SOUND_UNMATCHED)
			CheckDlgButton(IDC_UNMATCHED_POLICY, BST_UNCHECKED);
		else
			CheckDlgButton(IDC_UNMATCHED_POLICY, BST_CHECKED);

		if( g_p3p_preferences.enable_sounds & P3PPreferences::ENABLE_SOUND_MATCHED)
			CheckDlgButton(IDC_MATCHED_POLICY, BST_UNCHECKED);
		else
			CheckDlgButton(IDC_MATCHED_POLICY, BST_CHECKED);

		if( g_p3p_preferences.enable_sounds & P3PPreferences::PLAY_SOUND_CACHED_POLICY)
			CheckDlgButton(IDC_NEW_POLICY, BST_UNCHECKED);
		else
			CheckDlgButton(IDC_NEW_POLICY, BST_CHECKED);
	}


	HWND hotkey_mod_combo = GetDlgItem(IDC_HOTKEY_MODIFIER);

	SendMessage(hotkey_mod_combo, CB_ADDSTRING, 0, (LPARAM)("CTRL") );
	SendMessage(hotkey_mod_combo, CB_ADDSTRING, 1, (LPARAM)("CTRL+ALT") );
	SendMessage(hotkey_mod_combo, CB_ADDSTRING, 2, (LPARAM)("CTRL+SHIFT") );
	SendMessage(hotkey_mod_combo, CB_ADDSTRING, 3, (LPARAM)("CTRL+ALT+SHIFT") );

	switch( g_p3p_preferences.hotkey_mod )
	{
		case 1: SendMessage(hotkey_mod_combo, CB_SETCURSEL, 0, 0 );
				break;

		case 3: SendMessage(hotkey_mod_combo, CB_SETCURSEL, 1, 0 );
				break;

		case 5: SendMessage(hotkey_mod_combo, CB_SETCURSEL, 2, 0 );
				break;
			
		case 7: SendMessage(hotkey_mod_combo, CB_SETCURSEL, 3, 0 );
				break;
	}
			
	HWND hotkey_key_combo = GetDlgItem(IDC_HOTKEY_KEY);

	SendMessage(hotkey_key_combo, CB_ADDSTRING, 0, (LPARAM)("F9") );
	SendMessage(hotkey_key_combo, CB_ADDSTRING, 1, (LPARAM)("F10") );
	SendMessage(hotkey_key_combo, CB_ADDSTRING, 2, (LPARAM)("F11") );
	SendMessage(hotkey_key_combo, CB_ADDSTRING, 3, (LPARAM)("F12") );

	switch( g_p3p_preferences.hotkey_key )
	{
		case VK_F9: SendMessage(hotkey_key_combo, CB_SETCURSEL, 0, 0 );
				break;

		case VK_F10: SendMessage(hotkey_key_combo, CB_SETCURSEL, 1, 0 );
				break;

		case VK_F11: SendMessage(hotkey_key_combo, CB_SETCURSEL, 2, 0 );
				break;

		case VK_F12: SendMessage(hotkey_key_combo, CB_SETCURSEL, 3, 0 );
				break;
	}
			

	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT COtherSettingsDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{
	return 1;  
}


LRESULT COtherSettingsDialog::OnAutoUpgrade(WORD, WORD, HWND, BOOL&)
{
//	if( IsDlgButtonChecked(hdlg, IDC_STOP_BEGINNER) == BST_CHECKED )
//	{
	return 1;
}

LRESULT COtherSettingsDialog::OnOK(WORD, WORD, HWND, BOOL&)
{

	bool s_upgrade = g_p3p_preferences.check_upgrade;
	int s_sounds = g_p3p_preferences.enable_sounds;
	int s_hotkey_mod = g_p3p_preferences.hotkey_mod;
	int s_hotkey_key = g_p3p_preferences.hotkey_key;
	int s_user_prefs = g_p3p_preferences.user_prefs;

	if (IsDlgButtonChecked(IDC_AUTOUPGRADE) == BST_CHECKED)
		g_p3p_preferences.check_upgrade = true;
	else 
		g_p3p_preferences.check_upgrade = false;

	if (IsDlgButtonChecked(IDC_DISABLE_ANIMATION) == BST_CHECKED)
		g_p3p_preferences.user_prefs |= P3PPreferences::DISABLE_ANIMATION;
	else
		g_p3p_preferences.user_prefs &= ~P3PPreferences::DISABLE_ANIMATION;

	//disable popup windows
	if (IsDlgButtonChecked(IDC_DISABLE_POPUPS) == BST_CHECKED)
		g_p3p_preferences.user_prefs |= P3PPreferences::DISABLE_POPUP_WINDOWS;
	else
		g_p3p_preferences.user_prefs &= ~P3PPreferences::DISABLE_POPUP_WINDOWS;


	g_p3p_preferences.enable_sounds = P3PPreferences::DISABLE_SOUNDS;
	if (IsDlgButtonChecked(IDC_DISABLE_SOUNDS) == BST_UNCHECKED)
	{
		if( IsDlgButtonChecked(IDC_UNKNOWN_POLICY) == BST_UNCHECKED )
			g_p3p_preferences.enable_sounds += P3PPreferences::ENABLE_SOUND_UNKNOWN;
		if( IsDlgButtonChecked(IDC_UNMATCHED_POLICY) == BST_UNCHECKED )
			g_p3p_preferences.enable_sounds += P3PPreferences::ENABLE_SOUND_UNMATCHED;
		if( IsDlgButtonChecked(IDC_MATCHED_POLICY) == BST_UNCHECKED )
			g_p3p_preferences.enable_sounds += P3PPreferences::ENABLE_SOUND_MATCHED;
		if( IsDlgButtonChecked(IDC_NEW_POLICY) == BST_UNCHECKED )
			g_p3p_preferences.enable_sounds += P3PPreferences::PLAY_SOUND_CACHED_POLICY;

		
	}

	HWND hotkey_mod_combo = GetDlgItem(IDC_HOTKEY_MODIFIER);

	switch ( SendMessage(hotkey_mod_combo, CB_GETCURSEL, 0, 0 ) )
	{
		case 0: g_p3p_preferences.hotkey_mod = 1; break;
				
		case 1: g_p3p_preferences.hotkey_mod = 3; break;

		case 2: g_p3p_preferences.hotkey_mod = 5; break;

		case 3: g_p3p_preferences.hotkey_mod = 7; break;
	}


	HWND hotkey_key_combo = GetDlgItem(IDC_HOTKEY_KEY);

	switch ( SendMessage(hotkey_key_combo, CB_GETCURSEL, 0, 0 ) )
	{
		case 0: g_p3p_preferences.hotkey_key = VK_F9; break;

		case 1: g_p3p_preferences.hotkey_key = VK_F10; break;
				
		case 2: g_p3p_preferences.hotkey_key = VK_F11; break;

		case 3: g_p3p_preferences.hotkey_key = VK_F12; break;
	}

	if( (s_upgrade != g_p3p_preferences.check_upgrade) ||
		(s_sounds != g_p3p_preferences.enable_sounds)  ||
		(s_hotkey_mod != g_p3p_preferences.hotkey_mod) ||
		(s_hotkey_key != g_p3p_preferences.hotkey_key) ||
		(s_user_prefs != g_p3p_preferences.user_prefs)
	  )
	{
		g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
		SendCommandToAllP3Ps(ID_CHANGED_INIT);
	}

	if( (s_hotkey_mod != g_p3p_preferences.hotkey_mod) ||
		(s_hotkey_key != g_p3p_preferences.hotkey_key)
	  )
	{
		// Set the new HOTKEY
		SendMessage(WM_SETHOTKEY, (WPARAM) MAKEWORD(g_p3p_preferences.hotkey_key, cvt_hotkey_mod(g_p3p_preferences.hotkey_mod) ) );	

		// Display message to user 
		MessageBox("The short-cut key change will take effect after you restart your browser.", "Note", MB_OK | MB_ICONINFORMATION);
	}

	EndDialog(IDOK);
	return 1;

}

LRESULT COtherSettingsDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDCANCEL);
	return 1;

}


LRESULT COtherSettingsDialog::OnContextHelp(UINT id, WPARAM wParam, LPARAM lParam, BOOL& bFlag)
{

	HELPINFO* pHelpInfo = (LPHELPINFO) lParam;
	
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp( (HWND)pHelpInfo->hItemHandle, g_dllpath+"\\p3pclient.chm::/ContextSensitiveHelp.txt",
				HH_TP_HELP_WM_HELP, (DWORD)(LPVOID)help_array)  != NULL;
	}
	return 1;

}

LRESULT COtherSettingsDialog::OnClickedDisableSounds(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// TODO : Add Code for control notification handler.
	if (IsDlgButtonChecked(IDC_DISABLE_SOUNDS) == BST_CHECKED)
	{
		::EnableWindow(GetDlgItem(IDC_UNKNOWN_POLICY), FALSE);
		::EnableWindow(GetDlgItem(IDC_MATCHED_POLICY), FALSE);
		::EnableWindow(GetDlgItem(IDC_UNMATCHED_POLICY), FALSE);
		::EnableWindow(GetDlgItem(IDC_NEW_POLICY), FALSE);
	}
	else
	{
		::EnableWindow(GetDlgItem(IDC_UNKNOWN_POLICY), TRUE);
		::EnableWindow(GetDlgItem(IDC_MATCHED_POLICY), TRUE);
		::EnableWindow(GetDlgItem(IDC_UNMATCHED_POLICY), TRUE);
		::EnableWindow(GetDlgItem(IDC_NEW_POLICY), TRUE);
	}


	return 0;
}

LRESULT COtherSettingsDialog::OnHelp(WORD, WORD, HWND, BOOL&)
{

	return HtmlHelp( NULL, g_dllpath+"\\p3pclient.chm::/help-othersettings.html",
				HH_DISPLAY_TOPIC, 0)  != NULL;

}

