// PrivacySettingsDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "PrivacySettingsDialog.h"
#include "P3PPreferences.h"
#include "commctrl.h"
#include <stdio.h>
#include "Globals.h"
#include "GOS.h"
#include "SaxXmlParse.h"

#define TEMP_IMPORTED_PREFERENCE_FILE "\\temp-appel-imported.xml"

/////////////////////////////////////////////////////////////////////////////
// CPrivacySettingsDialog dialog


CPrivacySettingsDialog::CPrivacySettingsDialog() 
{
	// Store the pointer to the CP3PObject class
	isImported = false;
}


CPrivacySettingsDialog::~CPrivacySettingsDialog()
{
}


LRESULT CPrivacySettingsDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{
	save_settings = g_p3p_preferences;
	
	InitWarnings();

	return 1;  
}


int CPrivacySettingsDialog::InitWarnings()
{
	CheckDlgButton(IDC_LOW_PRIVACY, BST_UNCHECKED);
	CheckDlgButton(IDC_MEDIUM_PRIVACY, BST_UNCHECKED); 
	CheckDlgButton(IDC_HIGH_PRIVACY, BST_UNCHECKED);
	CheckDlgButton(IDC_CUSTOM_PRIVACY, BST_UNCHECKED);
	CheckDlgButton(IDC_IMPORTED_PRIVACY, BST_UNCHECKED);

	switch (g_p3p_preferences.privacy_level)
	{
		case P3PPreferences::LOW :
			CheckDlgButton(IDC_LOW_PRIVACY, BST_CHECKED); break;

		case P3PPreferences::MEDIUM :
			CheckDlgButton(IDC_MEDIUM_PRIVACY, BST_CHECKED); break;

		case P3PPreferences::HIGH :
			CheckDlgButton(IDC_HIGH_PRIVACY, BST_CHECKED); break;

		case P3PPreferences::CUSTOM_PRIVACY :
			CheckDlgButton(IDC_CUSTOM_PRIVACY, BST_CHECKED); break;

		case P3PPreferences::IMPORTED_PRIVACY :
			CheckDlgButton(IDC_IMPORTED_PRIVACY, BST_CHECKED); break;
	}

	
	::EnableWindow(GetDlgItem(IDC_IMPORTED_PRIVACY), GOS::is_file(g_dllpath+IMPORTED_PREFERENCE_FILE)||isImported);

	if( g_p3p_preferences.privacy_level == P3PPreferences::IMPORTED_PRIVACY)
	{
		::EnableWindow(GetDlgItem(IDC_MEDICAL_ANALYSIS), FALSE);
		::EnableWindow(GetDlgItem(IDC_MEDICAL_SHARE), FALSE);
		::EnableWindow(GetDlgItem(IDC_FINANCIAL_ANALYSIS), FALSE);
		::EnableWindow(GetDlgItem(IDC_FINANCIAL_SHARE), FALSE);
		::EnableWindow(GetDlgItem(IDC_NONPERSONAL_ANALYSIS), FALSE);
		::EnableWindow(GetDlgItem(IDC_NONPERSONAL_SHARE), FALSE);
		::EnableWindow(GetDlgItem(IDC_PERSONAL_ANALYSIS), FALSE);
		::EnableWindow(GetDlgItem(IDC_PERSONAL_SHARE), FALSE);
		::EnableWindow(GetDlgItem(IDC_CONTACT_MAIL), FALSE);
		::EnableWindow(GetDlgItem(IDC_CONTACT_PHONE), FALSE);
		::EnableWindow(GetDlgItem(IDC_NO_REMOVE_MAILINGLIST), FALSE);
		::EnableWindow(GetDlgItem(IDC_NO_ACCESS_DATA), FALSE);
	}
	else
	{
		::EnableWindow(GetDlgItem(IDC_MEDICAL_ANALYSIS), TRUE);
		::EnableWindow(GetDlgItem(IDC_MEDICAL_SHARE), TRUE);
		::EnableWindow(GetDlgItem(IDC_FINANCIAL_ANALYSIS), TRUE);
		::EnableWindow(GetDlgItem(IDC_FINANCIAL_SHARE), TRUE);
		::EnableWindow(GetDlgItem(IDC_NONPERSONAL_ANALYSIS), TRUE);
		::EnableWindow(GetDlgItem(IDC_NONPERSONAL_SHARE), TRUE);
		::EnableWindow(GetDlgItem(IDC_PERSONAL_ANALYSIS), TRUE);
		::EnableWindow(GetDlgItem(IDC_PERSONAL_SHARE), TRUE);
		::EnableWindow(GetDlgItem(IDC_CONTACT_MAIL), TRUE);
		::EnableWindow(GetDlgItem(IDC_CONTACT_PHONE), TRUE);
		::EnableWindow(GetDlgItem(IDC_NO_REMOVE_MAILINGLIST), TRUE);
		::EnableWindow(GetDlgItem(IDC_NO_ACCESS_DATA), TRUE);
	}

	if( g_p3p_preferences.warn_medical_analysis )
	{
		 CheckDlgButton(IDC_MEDICAL_ANALYSIS, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_MEDICAL_ANALYSIS, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_medical_share )
	{
		 CheckDlgButton(IDC_MEDICAL_SHARE, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_MEDICAL_SHARE, BST_UNCHECKED);
	}

	if( g_p3p_preferences.warn_financial_analysis )
	{
		CheckDlgButton(IDC_FINANCIAL_ANALYSIS, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_FINANCIAL_ANALYSIS, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_financial_share )
	{
		CheckDlgButton(IDC_FINANCIAL_SHARE, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_FINANCIAL_SHARE, BST_UNCHECKED);
	}


	if( g_p3p_preferences.warn_nonpersonal_analysis)
	{
		CheckDlgButton(IDC_NONPERSONAL_ANALYSIS, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_NONPERSONAL_ANALYSIS, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_nonpersonal_share)
	{
		CheckDlgButton(IDC_NONPERSONAL_SHARE, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_NONPERSONAL_SHARE, BST_UNCHECKED);
	}

	if( g_p3p_preferences.warn_personal_analysis)
	{
		CheckDlgButton(IDC_PERSONAL_ANALYSIS, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_PERSONAL_ANALYSIS, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_personal_share)
	{
		CheckDlgButton(IDC_PERSONAL_SHARE, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_PERSONAL_SHARE, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_contact_mail)
	{
		CheckDlgButton(IDC_CONTACT_MAIL, BST_CHECKED);
	} 
	else  
	{
		CheckDlgButton(IDC_CONTACT_MAIL, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_contact_phone)
	{
		CheckDlgButton(IDC_CONTACT_PHONE, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_CONTACT_PHONE, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_no_remove_mailinglist)
	{
		CheckDlgButton(IDC_NO_REMOVE_MAILINGLIST, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_NO_REMOVE_MAILINGLIST, BST_UNCHECKED);
	}
	if( g_p3p_preferences.warn_no_access_data)
	{
		CheckDlgButton(IDC_NO_ACCESS_DATA, BST_CHECKED);
	} 
	else
	{
		CheckDlgButton(IDC_NO_ACCESS_DATA, BST_UNCHECKED);
	}


	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT CPrivacySettingsDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT CPrivacySettingsDialog::OnOK(WORD, WORD, HWND, BOOL&)
{

/*	HWND level_combo = GetDlgItem(IDC_PRIVACY_LEVEL);

	switch( SendMessage(level_combo, CB_GETCURSEL, 0, 0 ) )
	{
		case 0:
			g_p3p_preferences.privacy_level= P3PPreferences::LOW; 
			break;

		case 1:
			g_p3p_preferences.privacy_level= P3PPreferences::MEDIUM; 
			break;

		case 2:
			g_p3p_preferences.privacy_level= P3PPreferences::HIGH; 
			break;

		case 3:
			g_p3p_preferences.privacy_level= P3PPreferences::CUSTOM_PRIVACY; 
			break;
	}
	*/

	if( (g_p3p_preferences.privacy_level == P3PPreferences::IMPORTED_PRIVACY) )
	{
		if( isImported )
		{
			_unlink(g_dllpath+IMPORTED_PREFERENCE_FILE);
			if( rename(g_dllpath+TEMP_IMPORTED_PREFERENCE_FILE, g_dllpath+IMPORTED_PREFERENCE_FILE) )
				MessageBox("Failed to create import file", "Error");
			g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
			EndDialog(IDOK);
			SendCommandToAllP3Ps(ID_CHANGED_PREFERENCES);
		}
		else if(g_p3p_preferences.privacy_level != save_settings.privacy_level)
		{
			g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
			EndDialog(IDOK);
			SendCommandToAllP3Ps(ID_CHANGED_PREFERENCES);
		}
		else
		{
			EndDialog(IDCANCEL);
		}
		return 1;
	}
	
	if( (g_p3p_preferences.privacy_level != P3PPreferences::CUSTOM_PRIVACY) &&
		(g_p3p_preferences.privacy_level == save_settings.privacy_level)  )
	{
		//nothing has changed -- no need to process or save.
		EndDialog(IDCANCEL);
		return 1;
	}

	if( IsDlgButtonChecked(IDC_MEDICAL_ANALYSIS) == BST_CHECKED)
		g_p3p_preferences.warn_medical_analysis = true;
	else  
		g_p3p_preferences.warn_medical_analysis = false;
	
	if( IsDlgButtonChecked(IDC_MEDICAL_SHARE) == BST_CHECKED)
		g_p3p_preferences.warn_medical_share = true;
	else  
		g_p3p_preferences.warn_medical_share = false;
	
	if( IsDlgButtonChecked(IDC_FINANCIAL_ANALYSIS) == BST_CHECKED)
		g_p3p_preferences.warn_financial_analysis = true;
	else  
		g_p3p_preferences.warn_financial_analysis = false;

	if( IsDlgButtonChecked(IDC_FINANCIAL_SHARE) == BST_CHECKED)
		g_p3p_preferences.warn_financial_share = true;
	else  
		g_p3p_preferences.warn_financial_share = false;


	if( IsDlgButtonChecked(IDC_NONPERSONAL_ANALYSIS) == BST_CHECKED)
		g_p3p_preferences.warn_nonpersonal_analysis = true;
	else  
		g_p3p_preferences.warn_nonpersonal_analysis = false;

	if( IsDlgButtonChecked(IDC_NONPERSONAL_SHARE) == BST_CHECKED)
		g_p3p_preferences.warn_nonpersonal_share = true;
	else  
		g_p3p_preferences.warn_nonpersonal_share = false;

	if( IsDlgButtonChecked(IDC_PERSONAL_ANALYSIS) == BST_CHECKED)
		g_p3p_preferences.warn_personal_analysis = true;
	else  
		g_p3p_preferences.warn_personal_analysis = false;

	if( IsDlgButtonChecked(IDC_PERSONAL_SHARE) == BST_CHECKED)
		g_p3p_preferences.warn_personal_share = true;
	else  
		g_p3p_preferences.warn_personal_share = false;

	if( IsDlgButtonChecked(IDC_CONTACT_MAIL) == BST_CHECKED)
		g_p3p_preferences.warn_contact_mail = true;
	else  
		g_p3p_preferences.warn_contact_mail = false;

	if( IsDlgButtonChecked(IDC_CONTACT_PHONE) == BST_CHECKED)
		g_p3p_preferences.warn_contact_phone = true;
	else  
		g_p3p_preferences.warn_contact_phone = false;


	if( IsDlgButtonChecked(IDC_NO_REMOVE_MAILINGLIST) == BST_CHECKED)
		g_p3p_preferences.warn_no_remove_mailinglist = true;
	else  
		g_p3p_preferences.warn_no_remove_mailinglist = false;

	if( IsDlgButtonChecked(IDC_NO_ACCESS_DATA) == BST_CHECKED)
		g_p3p_preferences.warn_no_access_data = true;
	else  
		g_p3p_preferences.warn_no_access_data = false;

	/*if( g_p3p_preferences == save_settings )
	{
		EndDialog(IDCANCEL);
	}
	else*/
	{
		g_p3p_preferences.InitializationSave(g_dllpath+INITIALIZATION_FILE);
		g_p3p_preferences.PreferenceSave(g_dllpath+PREFERENCE_FILE);

		EndDialog(IDOK);
		SendCommandToAllP3Ps(ID_CHANGED_PREFERENCES);
	}
	return 1;
}


LRESULT CPrivacySettingsDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
/*	g_p3p_preferences.privacy_level= (P3PPreferences::PrivacyLevels) save_privacy_level; 
	g_p3p_preferences.warn_personal= save_warn_personal; 
	g_p3p_preferences.warn_medical= save_warn_medical; 
	g_p3p_preferences.warn_financial= save_warn_financial;
	g_p3p_preferences.warn_nonpersonal_research= save_warn_nonpersonal_research; 
	g_p3p_preferences.warn_nonpersonal_decide_content= save_warn_nonpersonal_decide_content; 
	g_p3p_preferences.warn_nonpersonal_share_thirdparty= save_warn_nonpersonal_share_thirdparty; 
	g_p3p_preferences.warn_personal_research= save_warn_personal_research; 
	g_p3p_preferences.warn_personal_decide_content= save_warn_personal_decide_content; 
	g_p3p_preferences.warn_personal_contact_mail= save_warn_personal_contact_mail; 
	g_p3p_preferences.warn_personal_contact_phone= save_warn_personal_contact_phone; 
	g_p3p_preferences.warn_personal_share_thirdparty= save_warn_personal_share_thirdparty; 
	g_p3p_preferences.warn_no_remove_mailinglist= save_warn_no_remove_mailinglist; 
	g_p3p_preferences.warn_no_access_data= save_warn_no_access_data; 
*/
	g_p3p_preferences = save_settings;
	if( GOS::is_file(g_dllpath+TEMP_IMPORTED_PREFERENCE_FILE) )
		_unlink(g_dllpath+TEMP_IMPORTED_PREFERENCE_FILE);
	EndDialog(IDCANCEL);
	return 1;
}


LRESULT CPrivacySettingsDialog::OnContextHelp(UINT id, WPARAM wParam, LPARAM lParam, BOOL& bFlag)
{
	::MessageBeep(MB_OK);
	return 1;
}



LRESULT CPrivacySettingsDialog::OnClickedExport(WORD wNotifyCode, WORD wID, HWND hwnd, BOOL& bHandled)
{
	char export_file_name[2048]="MyPrivacyPreferences.xml";    /*defaultFileName*/

	char FilterStr[1000];
	char *tstr = FilterStr;
	sprintf(tstr, "XML Files (*.xml)");
	tstr += strlen(tstr)+1;
	sprintf(tstr, "*.xml");
	tstr += strlen(tstr)+1;
	*tstr = 0;

	const char WindowTitle[]="Export Preferences To File";
   ::OPENFILENAME filename;
	filename.lStructSize = sizeof( filename );
	filename.hwndOwner = hwnd;
	filename.hInstance = 0;
	filename.lpstrFilter = FilterStr;//"XML files (*.xml)\000*.xml\000\000";
	filename.lpstrCustomFilter = 0;
	filename.nMaxCustFilter = 0;
	filename.nFilterIndex = 0;
	filename.lpstrFile = export_file_name;
	filename.nMaxFile = 1024;
	filename.lpstrFileTitle = 0;
	filename.nMaxFileTitle = 0;
	filename.lpstrInitialDir = 0;
	filename.lpstrTitle = (char*)(const char *)WindowTitle;
	filename.Flags = OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
	filename.nFileOffset = 0;
	filename.lpstrDefExt = "xml";

	if( GetSaveFileName(&filename) )
	{
		if( g_p3p_preferences.privacy_level== P3PPreferences::IMPORTED_PRIVACY)
		{
			GString import_file;
			if( GOS::is_file(g_dllpath+IMPORTED_PREFERENCE_FILE) )
				import_file = g_dllpath+IMPORTED_PREFERENCE_FILE;
			else if( GOS::is_file(g_dllpath+TEMP_IMPORTED_PREFERENCE_FILE) )
				import_file = g_dllpath+TEMP_IMPORTED_PREFERENCE_FILE;

			if( !import_file.length() || ( FileCopy(import_file, export_file_name) < 0 ) )
			{
				MessageBox("Failed to create Export file", "Error");
				return -1;
			}
			else
				return 1;
		}
		else
		{
			if( g_p3p_preferences.PreferenceSave(export_file_name) )
				return 1;
			else
				return -1;
		}
    }
	else
		return 0;

}

LRESULT CPrivacySettingsDialog::OnClickedImport(WORD wNotifyCode, WORD wID, HWND hwnd, BOOL& bHandled)
{
	char import_file_name[2048]="";    /*defaultFileName*/

	char FilterStr[1000];
	char *tstr = FilterStr;
	sprintf(tstr, "XML Files (*.xml)");
	tstr += strlen(tstr)+1;
	sprintf(tstr, "*.xml");
	tstr += strlen(tstr)+1;
	*tstr = 0;

	const char WindowTitle[]="Import Preferences From File";
   ::OPENFILENAME filename;
	filename.lStructSize = sizeof( filename );
	filename.hwndOwner = hwnd;
	filename.hInstance = 0;
	filename.lpstrFilter = FilterStr;//"XML files (*.xml)\000*.xml\000\000";
	filename.lpstrCustomFilter = 0;
	filename.nMaxCustFilter = 0;
	filename.nFilterIndex = 0;
	filename.lpstrFile = import_file_name;
	filename.nMaxFile = 1024;
	filename.lpstrFileTitle = 0;
	filename.nMaxFileTitle = 0;
	filename.lpstrInitialDir = 0;
	filename.lpstrTitle = (char*)(const char *)WindowTitle;
	filename.Flags = OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
	filename.nFileOffset = 0;
	filename.lpstrDefExt = "xml";

	if( GetOpenFileName(&filename) )
	{
		TRY
		{
			if( ValidAppelFile(import_file_name) )
			{
				if( FileCopy(import_file_name, g_dllpath+TEMP_IMPORTED_PREFERENCE_FILE) < 0 )
				{
					MessageBox("Failed to create Import file", "Error");
					return -1;
				}
				else
				{
					isImported = true;
					g_p3p_preferences.privacy_level= P3PPreferences::IMPORTED_PRIVACY;
					g_p3p_preferences.GetCurPreferenceFile(true);
					InitWarnings();
					return 1;
				}
			}
			else 
				THROW("Invalid Appel File");
		}
		CATCH(ex)
		{
			MessageBox(ex.get_cause(), "Importing Error", MB_ICONERROR|MB_OK);
		}
		ENDCATCH;
		
    }

	return 0;

}

/*
LRESULT CPrivacySettingsDialog::OnSelchangePrivacyLevel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	HWND level_combo = GetDlgItem(IDC_PRIVACY_LEVEL);

	switch( SendMessage(level_combo, CB_GETCURSEL, 0, 0 ) )
	{
		case 0:
			g_p3p_preferences.privacy_level= P3PPreferences::LOW; 
			break;
		case 1:
			g_p3p_preferences.privacy_level= P3PPreferences::MEDIUM; 
			break;
		case 2:
			g_p3p_preferences.privacy_level= P3PPreferences::HIGH; 
			break;
		case 3:
			g_p3p_preferences.privacy_level= P3PPreferences::CUSTOM_PRIVACY; 
			break;
	}

	g_p3p_preferences.GetCurPreferenceFile(true);
	InitWarnings();
	return 1;
}
*/

LRESULT CPrivacySettingsDialog::OnClickedLowPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	g_p3p_preferences.privacy_level= P3PPreferences::LOW; 
	g_p3p_preferences.GetCurPreferenceFile(true);
	InitWarnings();
	return 1;
}

LRESULT CPrivacySettingsDialog::OnClickedMediumPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	g_p3p_preferences.privacy_level= P3PPreferences::MEDIUM; 
	g_p3p_preferences.GetCurPreferenceFile(true);
	InitWarnings();
	return 1;
}

LRESULT CPrivacySettingsDialog::OnClickedHighPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	g_p3p_preferences.privacy_level= P3PPreferences::HIGH; 
	g_p3p_preferences.GetCurPreferenceFile(true);
	InitWarnings();
	return 1;
}

LRESULT CPrivacySettingsDialog::OnClickedCustomPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	g_p3p_preferences.privacy_level= P3PPreferences::CUSTOM_PRIVACY; 
	g_p3p_preferences.GetCurPreferenceFile(true);
	InitWarnings();
	return 1;
}

LRESULT CPrivacySettingsDialog::OnClickedImportedPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	g_p3p_preferences.privacy_level= P3PPreferences::IMPORTED_PRIVACY; 
	g_p3p_preferences.GetCurPreferenceFile(true);
	InitWarnings();
	return 1;
}

LRESULT CPrivacySettingsDialog::OnClickedAnyWarning(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	g_p3p_preferences.privacy_level= P3PPreferences::CUSTOM_PRIVACY; 
	CheckDlgButton(IDC_CUSTOM_PRIVACY, BST_CHECKED);
	CheckDlgButton(IDC_LOW_PRIVACY, BST_UNCHECKED);
	CheckDlgButton(IDC_MEDIUM_PRIVACY, BST_UNCHECKED);
	CheckDlgButton(IDC_HIGH_PRIVACY, BST_UNCHECKED);
	return 1;
}

LRESULT CPrivacySettingsDialog::OnHelp(WORD, WORD, HWND, BOOL&)
{
	return HtmlHelp( NULL, g_dllpath+"\\p3pclient.chm::/help-privacypreferencesettings.html",
				HH_DISPLAY_TOPIC, 0)  != NULL;

}

int CheckNodeForRestrictions(GP<XmlNode> node, bool &isblockedBehavior)
{
	if( !node )
		return 0;

	//if( node->name == "P3P:EXTENSION" )
	//	THROW("P3P:EXTENSION element is not supported");
	//else 
	//if( node->name == "APPEL:REQUEST-GROUP" )
	//	THROW("APPEL:REQUEST-GROUP element is not supported");
	//else if( node->content.length() && !IsAllWhiteSpace(node->content) )
	//	THROW("PCDATA is not supported");

	GPosition childpos;
	GP<XmlNode> child = node->get_first_child(childpos);
	while(child)
	{
		bool lastIsRequest = false;
		
		if( node->name == "APPEL:RULESET" && child->name == "APPEL:RULE" )
		{
			if( GPosition pos = child->attrvalues.contains("BEHAVIOR") )
			{
#ifdef _DEBUG
				const char *t1 = child->attrvalues.key(pos);
				const char *t2 = child->attrvalues[pos];
#endif
				if( child->attrvalues[pos] == "block" )
				{
					isblockedBehavior = true;
					//THROW("blocked behaviour is not supported");
				}
				else if( child->attrvalues[pos] == "request" )
					lastIsRequest = true;
			}
					
		}
		CheckNodeForRestrictions(child, isblockedBehavior);

		child = node->get_next_child(childpos);
		//if( child && child->name == "APPEL:RULE" && lastIsRequest)
		//	THROW("Request behaviour is not supported in the non-last rule");
	}

	return 1;

}


int CPrivacySettingsDialog::ValidAppelFile(const char* filename)
{
	
	GP<XmlNode> root = SaxXmlParse(filename, true);//XMLParse(filename);
	if( root && root->name=="APPEL:RULESET" )
	{
		bool isblockbehavior=false;
		CheckNodeForRestrictions(root, isblockbehavior);
		if( isblockbehavior )
			MessageBox("The privacy preference file you have imported includes rules "
								  "designed to block access to web sites with certain privacy practices that "
								  "you may find objectionable. AT&T Privacy Bird will display a red bird at "
								  "these sites but it will not block them.", "Warning", MB_ICONWARNING|MB_OK);
		return 1;
	}
	else 
		return 0;
	
}




