#include <iostream.h>
#include "GOS.h"
#include "curl/curl.h"
#include "curl/types.h"
#include "curl/easy.h"

struct MemoryStruct {
  char *memory;
  size_t size;
};

size_t
WriteMemoryCallback(void *ptr, size_t size, size_t nmemb, void *data) {
  register int realsize = size * nmemb;
  struct MemoryStruct *mem = (struct MemoryStruct *)data;
  
  mem->memory = (char *)realloc(mem->memory, mem->size + realsize + 1);
  if (mem->memory) {
    memcpy(&(mem->memory[mem->size]), ptr, realsize);
    mem->size += realsize;
    mem->memory[mem->size] = 0;
  }
  return realsize;
}

char *GetPage(char const *url, GString &header) {
  CURL *curl_handle;
  struct MemoryStruct head;
  struct MemoryStruct body;
  
  body.memory = NULL;
  body.size = 0;
  head.memory = NULL;
  head.size = 0;
  curl_handle = curl_easy_init();
  curl_easy_setopt(curl_handle, CURLOPT_NOPROGRESS, 1);
  curl_easy_setopt(curl_handle, CURLOPT_MUTE, 1);
  curl_easy_setopt(curl_handle, CURLOPT_URL, url);
  curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION,WriteMemoryCallback);
  curl_easy_setopt(curl_handle, CURLOPT_FILE, (void *)&body);
  curl_easy_setopt(curl_handle,CURLOPT_HEADERFUNCTION,WriteMemoryCallback);
  curl_easy_setopt(curl_handle, CURLOPT_WRITEHEADER, (void *)&head);
  curl_easy_perform(curl_handle);
  curl_easy_cleanup(curl_handle);
  header = (GString)head.memory;
  return body.memory;
}

